<?php
/**
 * Copyright © Magefan (support@magefan.com). All rights reserved.
 * Please visit Magefan.com for license details (https://magefan.com/end-user-license-agreement).
 */

namespace Magefan\GuestToCustomer\Model\Config\Source;

class CustomerAssignGuestOrders implements \Magento\Framework\Option\ArrayInterface
{
    /**
     * @const int
     */
    const NO_OPTION = 0;

    /**
     * @const int
     */
    const EMAIL_CONFIRMATION_PROCESS = 1;

    /**
     * @const int
     */
    const WITHOUT_EMAIL_CONFIRMATION_PROCESS = 2;

    /**
     * Options int
     *
     * @return array
     */
    public function toOptionArray()
    {
        return  [
            ['value' => self::EMAIL_CONFIRMATION_PROCESS, 'label' => __('Yes (with email confirmation)')],
            ['value' => self::WITHOUT_EMAIL_CONFIRMATION_PROCESS, 'label' => __('Yes (without email confirmation)')],
            ['value' => self::NO_OPTION, 'label' => __('No')]
        ];
    }

    /**
     * Get options in "key-value" format
     *
     * @return array
     */
    public function toArray()
    {
        $array = [];
        foreach ($this->toOptionArray() as $item) {
            $array[$item['value']] = $item['label'];
        }
        return $array;
    }
}
