<?php

/**
 * Copyright © Magefan (support@magefan.com). All rights reserved.
 * Please visit Magefan.com for license details (https://magefan.com/end-user-license-agreement).
 */
namespace Magefan\GuestToCustomer\Model\Config\Source;

/**
 * Class ExtendGroup
 */
class Group extends \Magento\Customer\Model\Customer\Source\Group
{

      /**
       * @param bool $withEmpty
       * @param bool $defaultValues
       * @return array
       */
    public function toOptionArray($withEmpty = true, $defaultValues = false)
    {
        $options = [['value' => 0, 'label' => __('New Account Default Group')]];
        $parentOptions = parent::toOptionArray();
        foreach ($parentOptions as $group) {
            if (!in_array($group['value'], [
                \Magento\Customer\Model\Group::CUST_GROUP_ALL,
                \Magento\Customer\Model\Group::NOT_LOGGED_IN_ID,
            ])) {
                $filtered_groups[] = $group;
            }
        }
        $options = array_merge($options, $filtered_groups);
        return $options;
    }
}
