<?php
/**
 * Copyright © Magefan (support@magefan.com). All rights reserved.
 * Please visit Magefan.com for license details (https://magefan.com/end-user-license-agreement).
 */

namespace Magefan\GuestToCustomer\Model\Config\Source;

class InvalidOrderAddressAction implements \Magento\Framework\Option\ArrayInterface
{
    /**
     * @const int
     */
    const STOP_AND_DISPLAY_ERROR = 0;

    /**
     * @const int
     */
    const SKIP = 1;

    /**
     * Options int
     *
     * @return array
     */
    public function toOptionArray()
    {
        return  [
            ['value' => self::STOP_AND_DISPLAY_ERROR, 'label' => __('Skip and display error message')],
            ['value' => self::SKIP, 'label' => __('Skip')]
        ];
    }

    /**
     * Get options in "key-value" format
     *
     * @return array
     */
    public function toArray()
    {
        $array = [];
        foreach ($this->toOptionArray() as $item) {
            $array[$item['value']] = $item['label'];
        }
        return $array;
    }
}
