<?php
/**
 * Copyright © Magefan (support@magefan.com). All rights reserved.
 * Please visit Magefan.com for license details (https://magefan.com/end-user-license-agreement).
 */

declare(strict_types=1);

namespace Magefan\GuestToCustomer\Plugin\Magento\Customer\Model\Data;

/**
 * Plugin Address used to fix an issue with $customAttribute is null in
 * Magento\Framework\Reflection\CustomAttributesProcessor buildOutputDataArray()
 */
class Address
{
    /**
     * @param \Magento\Customer\Model\Data\Address $subject
     * @param $result
     * @return mixed
     */
    public function afterGetCustomAttributes(
        \Magento\Customer\Model\Data\Address $subject,
        $result
    ) {
        if ($result) {
            foreach ($result as $key => $value) {
                if (null === $value) {
                    unset($result[$key]);
                }
            }
        }
        return $result;
    }
}
