<?php
/**
 *
 * Copyright © 2015 Cisincommerce. All rights reserved.
 */
namespace Cisin\Clickforprice\Controller\Index;
use Magento\Framework\HTTP\PhpEnvironment\Request;
use Magento\Framework\Controller\ResultFactory;

class Send extends \Magento\Framework\App\Action\Action
{

    /**
     * @var \Magento\Framework\App\Cache\TypeListInterface
     */
    protected $_cacheTypeList;

    /**
     * @var \Magento\Framework\App\Cache\StateInterface
     */
    protected $_cacheState;

    /**
     * @var \Magento\Framework\App\Cache\Frontend\Pool
     */
    protected $_cacheFrontendPool;

    /**
     * @var \Magento\Framework\View\Result\PageFactory
     */
    protected $resultPageFactory;



    /**
     * @param Action\Context $context
     * @param \Magento\Framework\App\Cache\TypeListInterface $cacheTypeList
     * @param \Magento\Framework\App\Cache\StateInterface $cacheState
     * @param \Magento\Framework\App\Cache\Frontend\Pool $cacheFrontendPool
     * @param \Magento\Framework\View\Result\PageFactory $resultPageFactory
     */
    public function __construct(
        \Magento\Framework\App\Action\Context $context,
        \Magento\Framework\View\Result\PageFactory $resultPageFactory
    ) {
        parent::__construct($context);
        $this->resultPageFactory = $resultPageFactory;
    }

    /**
     * Flush cache storage
     *
     */
    public function execute()
    {  
        //print_r($this->getRequest()->getParams());die;
        $this->resultPage = $this->resultPageFactory->create();
        $resultRedirect = $this->resultFactory->create(ResultFactory::TYPE_REDIRECT);
        $product_id = $this->getRequest()->getParam('productId'); // Assign product id here
        $email = $this->getRequest()->getParam('email');
        $storeid = $this->getRequest()->getParam('storeid');

        $queryString = $this->getRequest()->getParam('queryString');
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $product = $objectManager->get('Magento\Catalog\Model\Product')->load($product_id)->getData();

        $storeManager = $objectManager->get('\Magento\Store\Model\StoreManagerInterface');
        $store = $storeManager->getStore();
        //print_r($product);die;

        $productName=$product['name'];
        $productSku=$product['sku'];
        $productUrl=$product['url_key'];
//echo $product['special_price'];
//o $_REQUEST['price'];

        if(array_key_exists('special_price', $product) && $product['special_price']){
            $cprice=number_format($product['special_price']+(($product['special_price']*20)/100),2,'.','');
            $price = $cprice+$_REQUEST['price'];
        }else{
            $cprice=number_format($product['price']+(($product['price']*20)/100),2,'.','');
            $price = $cprice+$_REQUEST['price'];
        }



        $objectManager = \Magento\Framework\App\ObjectManager::getInstance(); // Instance of Object Manager
        $storeManager = $objectManager->create('Magento\Store\Model\StoreManagerInterface');
        $_transportBuilder = $objectManager->create('Magento\Framework\Mail\Template\TransportBuilder');
        $inlineTranslation = $objectManager->create('Magento\Framework\Translate\Inline\StateInterface');
        $messageManager = $objectManager->create('\Magento\Framework\Message\ManagerInterface');
        $currentStore = $storeManager->getStore();
        $mediaUrl = $currentStore->getBaseUrl(\Magento\Framework\UrlInterface::URL_TYPE_MEDIA).'catalog/product/';

        //$product_main = $objectManager->get('Magento\Catalog\Model\Product')->load($product_id);
        $priceHelper = $objectManager->create('Magento\Framework\Pricing\Helper\Data'); // Instance of Pricing Helper
        $finalPrice = $priceHelper->currency($price, true, false);
        $templateOptions = array('area' => \Magento\Framework\App\Area::AREA_ADMINHTML, 'store' => $storeManager->getStore()->getId());

        if ($storeid=='3') {
            $productUrlMain = $store->getBaseUrl().$productUrl.".html?fromemail=1&".$queryString;
        }
        else{
            $productUrlMain = $store->getBaseUrl().$productUrl."?fromemail=1&".$queryString;
        }

        
        $templateVars = array(
            'customer_name'   => $this->getRequest()->getParam('name') ,
            'sku' => $productSku,
            'product_name' => $productName,
            'product_url' => $productUrlMain,
            'price' => $finalPrice,
            'product_image'=> $mediaUrl.$product['image']
        );
        $a = $store->getBaseUrl();

        if ($storeid=='3') {
            $from = array('email' => "sales@banyo.co.uk", 'name' => 'Banyo');
        }else{

            $from = array('email' => "sales@nexus-home.com", 'name' => 'Nexus');
        }
        $inlineTranslation->suspend();
        $to = array($email);
        if ($storeid=='3') {
            $tidentifier='20';
        }
        else{
            $tidentifier='2';

        }

        $transport = $_transportBuilder->setTemplateIdentifier($tidentifier)
            ->setTemplateOptions($templateOptions)
            ->setTemplateVars($templateVars)
            ->setFrom($from)
            ->addTo($to)
            ->getTransport();
try{
        $transport->sendMessage();
} catch (Exception $e){ echo $e; die();}

        $inlineTranslation->resume();

        if ($storeid=='3') {
            $resultRedirect->setUrl($store->getBaseUrl() . $productUrl .'.html'."/?" . $queryString);
        }
        else{
            $resultRedirect->setUrl($store->getBaseUrl() . $productUrl . "/?" . $queryString);

        }
        $messageManager->addSuccess(__("The price for this product has been sent to the email address you provided"));

        return $resultRedirect;

    }
}
