<?php
namespace Cisin\Salesordergrid\Observer;

use Magento\Framework\Event\ObserverInterface;

class SetItemDropdownAttribute implements ObserverInterface
{
    /**
     * @param \Magento\Framework\Event\Observer $observer
     * @return void
     * @SuppressWarnings(PHPMD.UnusedFormalParameter)
     */
    public function execute(\Magento\Framework\Event\Observer $observer)
    {
        $quoteItem = $observer->getQuoteItem();
        $product = $observer->getProduct();
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $product = $objectManager->create('Magento\Catalog\Model\Product')->load($quoteItem->getProductId());

        // Handle product_brand attribute
        $productBrandData = $product->getData('product_brand');
        $supplierValue = '';
        if (is_string($productBrandData) && !empty($productBrandData)) {
            $data = explode(',', $productBrandData);
            if (count($data)) {
                $attr = $product->getResource()->getAttribute('product_brand');
                if ($attr) {
                    $optionText = $attr->getSource()->getOptionText($data[0]);
                    $supplierValue = $optionText;
                }
            }
        }

        $quoteItem->setProductBrand($supplierValue);

        // Handle brand attribute
        $brandAttribute = $product->getResource()->getAttribute('brand');
        if ($brandAttribute) {
            $productBrand = $brandAttribute->getFrontend()->getValue($product);
            $quoteItem->setProductSupplier($productBrand);
            $quoteItem->setBrand($productBrand);
        } else {
            // Handle missing brand attribute
            $quoteItem->setProductSupplier('');
            $quoteItem->setBrand('');
        }
    }
}

