<?php

namespace Cisin\Salesordergrid\Ui\Component\Listing\Column;

use Magento\Framework\View\Element\UiComponentFactory;
use Magento\Framework\View\Element\UiComponent\ContextInterface;
use Magento\Sales\Model\OrderFactory;
use Magento\Framework\Pricing\Helper\Data as PriceHelper;
use Magento\Store\Model\StoreManagerInterface;

/**
 * @api
 * @since 100.0.2
 */
class Itemdetail extends \Magento\Ui\Component\Listing\Columns\Column
{
    protected $orderFactory;
    protected $priceHelper;
    protected $storeManager;

    /**
     * @param ContextInterface $context
     * @param UiComponentFactory $uiComponentFactory
     * @param OrderFactory $orderFactory
     * @param PriceHelper $priceHelper
     * @param StoreManagerInterface $storeManager
     * @param array $components
     * @param array $data
     */
    public function __construct(
        ContextInterface $context,
        UiComponentFactory $uiComponentFactory,
        OrderFactory $orderFactory,
        PriceHelper $priceHelper,
        StoreManagerInterface $storeManager,
        array $components = [],
        array $data = []
    ) {
        parent::__construct($context, $uiComponentFactory, $components, $data);
        $this->orderFactory = $orderFactory;
        $this->priceHelper = $priceHelper;
        $this->storeManager = $storeManager;
    }

    /**
     * Prepare Data Source
     *
     * @param array $dataSource
     * @return array
     */
    public function prepareDataSource(array $dataSource) 
    {
        if (isset($dataSource['data']['items'])) {
            foreach ($dataSource['data']['items'] as &$item) { 
                $pname = '<table style="width: 600px;"><tr><td>#</td><td style="width: 350px;">Product Name</td><td>Selling Price</td><td>Cost Price</td><td>PO</td></tr>';
                $i = 1;
                $order = $this->orderFactory->create()->load($item['entity_id']);
                $orderItems = $order->getAllItems();

                foreach ($orderItems as $data) {
                    $order_item = $data->getData();
                    
                    // Check if 'po_status' exists, and use a default value if not
                    $poStatus = isset($order_item['po_status']) ? $order_item['po_status'] : 'N/A'; 

                    // Add the data to the table
                    $pname .= "<tr><td>".$i."</td><td>".$data->getName()."</td>
                               <td>".$this->priceHelper->currency($data->getPrice(), true, false)."</td>
                               <td>".$this->priceHelper->currency($order_item['base_cost'] ?? 0, true, false)."</td>
                               <td>".$poStatus."</td>
                             </tr>";
                    $i++;         
                }

                $pname .= '</table>';
                $item['cost_price'] = $pname;
            }
        }
        return $dataSource;
    }
}
