<?php

namespace MagePsycho\MassImporterPro\Block\Adminhtml\System\Config\Form\Field;

use Magento\Backend\Block\Template\Context;
use Magento\Framework\Data\Form\Element\AbstractElement;
use MagePsycho\MassImporterPro\Model\Config\ModuleMetadata;
use MagePsycho\MassImporterPro\Helper\Data as MassImporterProHelper;

/**
 * @category   MagePsycho
 * @package    MagePsycho_MassImporterPro
 * @author     Raj KB <magepsycho@gmail.com>
 * @website    https://www.magepsycho.com
 * @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 */
class Version extends \Magento\Config\Block\System\Config\Form\Field
{
    /**
     * @var MassImporterProHelper
     */
    protected $helper;

    /**
     * @var ModuleMetadata
     */
    private $moduleMetadata;

    public function __construct(
        Context $context,
        MassImporterProHelper $helper,
        ModuleMetadata $moduleMetadata
    ) {
        $this->helper = $helper;
        $this->moduleMetadata = $moduleMetadata;
        parent::__construct($context);
    }

    protected function _getElementHtml(AbstractElement $element)
    {
        $element->setValue($this->moduleMetadata->getVersion());
        return $element->getValue();
    }
}
