<?php

namespace MagePsycho\MassImporterPro\Controller\Adminhtml;

use Magento\Backend\App\Action;
use MagePsycho\MassImporterPro\Helper\Data as MipHelper;
use MagePsycho\MassImporterPro\Helper\Report as ReportHelper;
use MagePsycho\MassImporterPro\Model\HistoryFactory;
use Magento\Framework\Filesystem\Io\File;
use Magento\Ui\Component\MassAction\Filter;

/**
 * @category   MagePsycho
 * @package    MagePsycho_MassImporterPro
 * @author     Raj KB <magepsycho@gmail.com>
 * @website    https://www.magepsycho.com
 * @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 */
abstract class History extends Action
{
    /**
     * Authorization level of a basic admin session
     *
     * @see _isAllowed()
     */
    const ADMIN_RESOURCE = 'MagePsycho_MassImporterPro::import';

    /**
     * @var MipHelper
     */
    private $mipHelper;

    /**
     * @var ReportHelper
     */
    protected $reportHelper;

    /**
     * @var HistoryFactory
     */
    protected $historyFactory;

    /**
     * @var File
     */
    protected $fileIo;

    /**
     * @var Filter
     */
    protected $filter;

    public function __construct(
        Action\Context $context,
        MipHelper $mipHelper,
        ReportHelper $reportHelper,
        HistoryFactory $historyFactory,
        File $fileIo,
        Filter $filter
    ) {
        $this->mipHelper = $mipHelper;
        $this->reportHelper = $reportHelper;
        $this->historyFactory = $historyFactory;
        $this->fileIo = $fileIo;
        $this->filter = $filter;

        parent::__construct($context);
    }

    public function deleteFile($file)
    {
        try {
            $this->fileIo->rm(
                $this->reportHelper->getReportAbsolutePath($file)
            );
        } catch (\Exception $e) {
            $this->mipHelper->log(__METHOD__ . ', Exception::' . $e->getMessage());
        }
    }
}
