<?php

namespace MagePsycho\MassImporterPro\Controller\Adminhtml\History;

use MagePsycho\MassImporterPro\Controller\Adminhtml\History as HistoryController;
use Magento\Framework\Controller\ResultFactory;

/**
 * @category   MagePsycho
 * @package    MagePsycho_MassImporterPro
 * @author     Raj KB <magepsycho@gmail.com>
 * @website    https://www.magepsycho.com
 * @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 */
class Delete extends HistoryController
{
    /**
     * Delete history
     *
     * @return \Magento\Backend\Model\View\Result\Redirect
     */
    public function execute()
    {
        /** @var \Magento\Backend\Model\View\Result\Redirect $resultRedirect */
        $resultRedirect = $this->resultFactory->create(ResultFactory::TYPE_REDIRECT);

        try {
            $history = $this->historyFactory->create()->load(
                $this->getRequest()->getParam('id')
            );

            // Deleted related files if available
            if ($history->getImportedFile()) {
                $this->deleteFile($history->getImportedFile());
            }
            if ($history->getErrorFile()) {
                $this->deleteFile($history->getErrorFile());
            }

            $history->delete();

            $this->messageManager->addSuccessMessage(__('You deleted the history.'));
        } catch (\Magento\Framework\Exception\LocalizedException $e) {
            $this->messageManager->addErrorMessage($e->getMessage());
            return $resultRedirect->setPath('magepsycho_massimporterpro/import/index');
        } catch (\Exception $e) {
            $this->messageManager->addErrorMessage(__("We're unable to delete the history."));
            $this->_objectManager->get('Psr\Log\LoggerInterface')->critical($e);
        }

        return $resultRedirect->setPath('magepsycho_massimporterpro/import/index');
    }
}
