<?php

namespace MagePsycho\MassImporterPro\Controller\Adminhtml\History;

use Magento\Framework\Controller\ResultFactory;
use MagePsycho\MassImporterPro\Controller\Adminhtml\History as HistoryController;

/**
 * @category   MagePsycho
 * @package    MagePsycho_MassImporterPro
 * @author     Raj KB <magepsycho@gmail.com>
 * @website    https://www.magepsycho.com
 * @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 */
class MassDelete extends HistoryController
{
    /**
     * Delete one or more histories
     *
     * @return void
     */
    public function execute()
    {
        $collection = $this->filter->getCollection($this->historyFactory->create()->getCollection());
        $collectionSize = $collection->getSize();

        foreach ($collection as $history) {
            // Deleted related files if available
            if ($history->getImportedFile()) {
                $this->deleteFile($history->getImportedFile());
            }
            if ($history->getErrorFile()) {
                $this->deleteFile($history->getErrorFile());
            }

            $history->delete();
        }

        $this->messageManager->addSuccessMessage(__('A total of %1 record(s) have been deleted.', $collectionSize));

        /** @var \Magento\Backend\Model\View\Result\Redirect $resultRedirect */
        $resultRedirect = $this->resultFactory->create(ResultFactory::TYPE_REDIRECT);
        return $resultRedirect->setPath('*/import/');
    }
}
