<?php

namespace MagePsycho\MassImporterPro\Model\Import\Source;

/**
 * Zip import adapter.
 *
 * @category   MagePsycho
 * @package    MagePsycho_MassImporterPro
 * @author     Raj KB <magepsycho@gmail.com>
 * @website    https://www.magepsycho.com
 * @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 */
class Zip extends Csv
{
    /**
     * @param string $file
     * @param \Magento\Framework\Filesystem\Directory\Write $directory
     * @param string $options
     */
    public function __construct(
        $file,
        \Magento\Framework\Filesystem\Directory\Write $directory,
        $options
    ) {
        $zip = new \Magento\Framework\Archive\Zip();
        $file = $zip->unpack(
            $directory->getRelativePath($file),
            $directory->getRelativePath(preg_replace('/\.zip$/i', '.csv', $file))
        );
        parent::__construct($file, $directory, $options);
    }
}
