<?php

namespace MagePsycho\MassImporterPro\Model\Source\Import;

/**
 * Source import entity model
 *
 * @category   MagePsycho
 * @package    MagePsycho_MassImporterPro
 * @author     Raj KB <magepsycho@gmail.com>
 * @website    https://www.magepsycho.com
 * @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 */
class Entity implements \Magento\Framework\Option\ArrayInterface
{
    /**
     * @var \MagePsycho\MassImporterPro\Model\Import\ConfigInterface
     */
    protected $_importConfig;

    /**
     * @param \MagePsycho\MassImporterPro\Model\Import\ConfigInterface $importConfig
     */
    public function __construct(\MagePsycho\MassImporterPro\Model\Import\ConfigInterface $importConfig)
    {
        $this->_importConfig = $importConfig;
    }

    /**
     * {@inheritdoc}
     */
    public function toOptionArray()
    {
        $options = [];
        $options[] = ['label' => __('-- Please Select --'), 'value' => ''];
        foreach ($this->_importConfig->getEntities() as $entityName => $entityConfig) {
            $options[] = ['label' => __($entityConfig['label']), 'value' => $entityName];
        }
        return $options;
    }
}
