<?php

namespace Cisin\Salesordergrid\Ui\Component\Listing\Column; 


use Magento\Framework\View\Element\UiComponentFactory;
use Magento\Framework\View\Element\UiComponent\ContextInterface;

/**
 * @api
 * @since 100.0.2
 */
class Brand extends \Magento\Ui\Component\Listing\Columns\Column
{
   

    /**
     * @param ContextInterface $context
     * @param UiComponentFactory $uiComponentFactory
     * @param \Magento\Framework\Locale\CurrencyInterface $localeCurrency
     * @param \Magento\Store\Model\StoreManagerInterface $storeManager
     * @param array $components
     * @param array $data
     */
    public function __construct(
        ContextInterface $context,
        UiComponentFactory $uiComponentFactory,
        \Magento\Store\Model\StoreManagerInterface $storeManager,
        array $components = [],
        array $data = []
    ) {
        parent::__construct($context, $uiComponentFactory, $components, $data);
        $this->storeManager = $storeManager;
    }

    /**
     * Prepare Data Source
     *
     * @param array $dataSource
     * @return array
     */

     public function prepareDataSource(array $dataSource) {
        
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance(); // Instance of Object Manager
        $priceHelper = $objectManager->create('Magento\Framework\Pricing\Helper\Data'); // Instance of Pricing Helper
    
        if (isset($dataSource['data']['items'])) {
            $fieldName = 'entity_id';//$this->getData('name');
            $brand_name='';
            $count=1;
            foreach ($dataSource['data']['items'] as & $item) { 
                     
                     $order = $objectManager->create('Magento\Sales\Model\Order')->load($item['entity_id']);
                     $orderItems = $order->getAllItems();                 
                    
                     foreach($orderItems as $data){                        
                        $order_item=$data->getData();
                        if(null !== $order_item['brand'] && strlen($order_item['brand'])>2){
                        $pcost='';
                        $brand_name.= $count.".".$order_item['brand']."<br/>";         
                         
                              
                        }else{

                            $product = $objectManager->create('Magento\Catalog\Model\Product')->load($data->getProductId());
                            $optionText = $product->getAttributeText('brand');
                            $pcost='';
                            $brand_name.= $count.".".$optionText."<br/>";      
                        }
                        $count++;
                     }

                     $item['brand'] = $brand_name;
                     $brand_name='';
                     $count=1;         
                      
            }

        }
        
        return $dataSource;
    }
    
}
