<?php

namespace MagePsycho\MassImporterPro\Block\Adminhtml\System\Config\Form\Field;

use Magento\Backend\Block\Template\Context;
use Magento\Config\Block\System\Config\Form\Field;
use Magento\Framework\Data\Form\Element\AbstractElement;
use MagePsycho\MassImporterPro\Helper\Data as MassImporterProHelper;

/**
 * @category   MagePsycho
 * @package    MagePsycho_MassImporterPro
 * @author     Raj KB <magepsycho@gmail.com>
 * @website    https://www.magepsycho.com
 * @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 */
class Domain extends Field
{
    /**
     * @var MassImporterProHelper
     */
    protected $helper;

    public function __construct(
        Context $context,
        MassImporterProHelper $helper
    ) {
        $this->helper = $helper;
        parent::__construct($context);
    }

    /**
     * @param AbstractElement $element
     * @return string
     */
    protected function _getElementHtml(AbstractElement $element)
    {
        $domain = $this->helper->getDomainFromSystemConfig();
        $element->setValue($domain);

        return $element->getValue();
    }
}
