<?php

namespace MagePsycho\MassImporterPro\Model\System\Config\Source;

/**
 * @category   MagePsycho
 * @package    MagePsycho_MassImporterPro
 * @author     Raj KB <magepsycho@gmail.com>
 * @website    https://www.magepsycho.com
 * @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 */
class ImportSource implements \Magento\Framework\Option\ArrayInterface
{
    const IMPORT_SOURCE_FILE                = 'file';
    const IMPORT_SOURCE_FILE_DESKTOP        = 'file_desktop';
    const IMPORT_SOURCE_FILE_SERVER         = 'file_server';
    const IMPORT_SOURCE_FILE_REMOTE_URL     = 'file_url';
    const IMPORT_SOURCE_FILE_REMOTE_SFTP    = 'file_ftp';
    const IMPORT_SOURCE_DIR_SERVER          = 'dir_server';

    protected $_options;

    public function getAllOptions($withEmpty = false)
    {
        if ($this->_options === null) {
            $this->_options = [
                [
                    'value' => self::IMPORT_SOURCE_FILE,
                    'label' => __('File (CSV)'),
                ],
                //@todo
                /*[
                    'value' => self::IMPORT_SOURCE_FILE_DESKTOP,
                    'label' => __('File from Desktop'),
                ],
                [
                    'value' => self::IMPORT_SOURCE_DIR_SERVER,
                    'label' => __('File(s) from Server Directory'),
                ],
                [
                    'value' => self::IMPORT_SOURCE_FILE_SERVER,
                    'label' => __('File from Local Server'),
                ],
                [
                    'value' => self::IMPORT_SOURCE_FILE_REMOTE_URL,
                    'label' => __('File from Remote URL'),
                ],
                [
                    'value' => self::IMPORT_SOURCE_FILE_REMOTE_SFTP,
                    'label' => __('File from Remote FTP/SFTP'),
                ],*/
            ];
        }
        $options = $this->_options;
        if ($withEmpty) {
            array_unshift($options, ['value' => '', 'label' => '']);
        }
        return $options;
    }

    public function getOptionsArray($withEmpty = true)
    {
        $options = [];
        foreach ($this->getAllOptions($withEmpty) as $option) {
            $options[$option['value']] = $option['label'];
        }
        return $options;
    }

    public function getOptionText($value)
    {
        $options = $this->getAllOptions(false);
        foreach ($options as $item) {
            if ($item['value'] == $value) {
                return $item['label'];
            }
        }
        return false;
    }

    public function toOptionArray()
    {
        return $this->getAllOptions();
    }

    public function toOptionHash($withEmpty = true)
    {
        return $this->getOptionsArray($withEmpty);
    }
}
