<?php

namespace MagePsycho\MipPricing\Model\Import\Pricing;

/**
 * @category   MagePsycho
 * @package    MagePsycho_MipPricing
 * @author     Raj KB <magepsycho@gmail.com>
 * @website    https://www.magepsycho.com
 * @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 */
interface RowValidatorInterface extends \Magento\Framework\Validator\ValidatorInterface
{
    const ERROR_SKU_IS_EMPTY        = 'skuEmpty';
    const ERROR_SKU_NOT_FOUND       = 'skuNotFound';

    const ERROR_WEBSITE_IS_EMPTY    = 'websiteEmpty';
    const ERROR_WEBSITE_NOT_FOUND   = 'websiteNotFound';
    const ERROR_INVALID_WEBSITE     = 'invalidWebsite';
    const ERROR_INVALID_STORE       = 'invalidStore';

    const ERROR_INVALID_TYPE        = 'invalidType';
    const ERROR_VALUE_IS_REQUIRED   = 'isRequired';
    const ERROR_NO_DEFAULT_ROW      = 'noDefaultRow';
    const ERROR_DUPLICATE_SKU       = 'duplicateSKU';

    const ERROR_INVALID_DATE                    = 'invalidDateValue';
    const ERROR_INVALID_TO_DATE                 = 'invalidToDateValue';
    const ERROR_INVALID_PRICE_VALUE             = 'invalidPriceValue';
    const ERROR_INVALID_PRICE_FORMAT            = 'invalidPriceFormat';

    const ERROR_INVALID_TIER_PRICE_QTY          = 'invalidTierPriceOrQty';
    const ERROR_INVALID_TIER_PRICE_SITE         = 'tierPriceWebsiteInvalid';
    const ERROR_INVALID_TIER_PRICE_GROUP        = 'tierPriceGroupInvalid';
    const ERROR_INVALID_TIER_PRICE_TYPE         = 'tierPriceTypeInvalid';

    const ERROR_TIER_DATA_IS_EMPTY              = 'tierPriceDataIsEmpty';
    const ERROR_TIER_DATA_INVALID               = 'tierPriceDataIsInvalid';

    const ERROR_GROUP_DATA_IS_EMPTY              = 'groupPriceDataIsEmpty';
    const ERROR_GROUP_DATA_INVALID               = 'groupPriceDataIsInvalid';

    const ERROR_SKU_NOT_FOUND_FOR_DELETE        = 'skuNotFoundToDelete';
    const ERROR_SUPER_PRODUCTS_SKU_NOT_FOUND    = 'superProductsSkuNotFound';
    const ERROR_MEDIA_DATA_INCOMPLETE           = 'mediaDataIsIncomplete';
    const ERROR_EXCEEDED_MAX_LENGTH             = 'exceededMaxLength';
    const ERROR_INVALID_ATTRIBUTE_TYPE          = 'invalidAttributeType';
    const ERROR_INVALID_ATTRIBUTE_DECIMAL       = 'invalidAttributeDecimal';
    const ERROR_ABSENT_REQUIRED_ATTRIBUTE       = 'absentRequiredAttribute';
    const ERROR_INVALID_ATTRIBUTE_OPTION        = 'absentAttributeOption';
    const ERROR_DUPLICATE_UNIQUE_ATTRIBUTE      = 'duplicatedUniqueAttribute';

    /**
     * Value that means all entities (e.g. websites, groups etc.)
     */
    const VALUE_ALL = 'ALL GROUPS';

    const FIELD_TIER_PRICE = 'tier_price';

    const DELETE_MARKER = 'x';

    const DELETE_QTY_VALUE = '-1';

    /**
     * Initialize validator
     *
     * @param \MagePsycho\MipPricing\Model\Import\Pricing $context
     * @return $this
     */
    public function init($context);
}
