<?php

namespace MagePsycho\MipPricing\Model\System\Config\Source;

use Magento\Framework\Option\ArrayInterface;
use Magento\Store\Model\System\Store;

/**
 * @category   MagePsycho
 * @package    MagePsycho_MipPricing
 * @author     Raj KB <magepsycho@gmail.com>
 * @website    https://www.magepsycho.com
 * @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 */
class Website implements ArrayInterface
{
    /**
     * System Store Model
     *
     * @var Store
     */
    protected $systemStore;

    public function __construct(Store $systemStore)
    {
        $this->systemStore = $systemStore;
    }

    /**
     * Return websites array
     *
     * @return array
     */
    public function toOptionArray()
    {
        $websites = $this->systemStore->getWebsiteOptionHash(true);
        ksort($websites);
        if (isset($websites[0])) {
            $websites[0] = __('Default Scope');
        }
        return $websites;
    }
}
