<?php
/**
 * Copyright © Magefan (support@magefan.com). All rights reserved.
 * Please visit Magefan.com for license details (https://magefan.com/end-user-license-agreement).
 */
namespace Magefan\GuestToCustomer\Plugin\Magento\Customer\Model;

use Magento\Customer\Api\Data\CustomerInterface;
use Magefan\GuestToCustomer\Model\Config;
use Magento\Customer\Model\EmailNotification;
use Magento\Framework\App\RequestInterface;

/**
 * Class EmailNotificationPlugin
 */
class EmailNotificationPlugin
{
    /**
     * @var Config
     */
    protected $config;

    /**
     * EmailNotificationPlugin constructor.
     * @param RequestInterface $request
     * @param Config $config
     */
    public function __construct(
        RequestInterface $request,
        Config $config

    ) {
        $this->request = $request;
        $this->config = $config;
    }

    /**
     * @param EmailNotification $subject
     * @param callable $proceed
     * @param CustomerInterface $customer
     * @param string $type
     * @param string $backUrl
     * @param int $storeId
     * @param null $sendemailStoreId
     * @return mixed
     */
    public function aroundNewAccount(
        EmailNotification $subject,
        callable $proceed,
        CustomerInterface $customer,
        $type = 'registered',
        $backUrl = '',
        $storeId = 0,
        $sendemailStoreId = null
    ) {
        if ($this->request->getModuleName() == 'mfguesttocustomer' && !$this->config->isNotificationMessagesEnabled()) {
            return;
        }
        return $proceed(
            $customer,
            $type,
            $backUrl,
            $storeId,
            $sendemailStoreId
        );
    }
}