-- MySQL dump 10.13  Distrib 8.0.41, for Linux (x86_64)
--
-- Host: localhost    Database: magentodb
-- ------------------------------------------------------
-- Server version	8.0.41-0ubuntu0.24.04.1

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!50503 SET NAMES utf8mb4 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `catalog_category_entity_int`
--

DROP TABLE IF EXISTS `catalog_category_entity_int`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_category_entity_int` (
  `value_id` int NOT NULL AUTO_INCREMENT COMMENT 'Value ID',
  `attribute_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `entity_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  `value` int DEFAULT NULL COMMENT 'Value',
  PRIMARY KEY (`value_id`),
  UNIQUE KEY `CATALOG_CATEGORY_ENTITY_INT_ENTITY_ID_ATTRIBUTE_ID_STORE_ID` (`entity_id`,`attribute_id`,`store_id`),
  KEY `CATALOG_CATEGORY_ENTITY_INT_ENTITY_ID` (`entity_id`),
  KEY `CATALOG_CATEGORY_ENTITY_INT_ATTRIBUTE_ID` (`attribute_id`),
  KEY `CATALOG_CATEGORY_ENTITY_INT_STORE_ID` (`store_id`),
  CONSTRAINT `CAT_CTGR_ENTT_INT_ATTR_ID_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `eav_attribute` (`attribute_id`) ON DELETE CASCADE,
  CONSTRAINT `CAT_CTGR_ENTT_INT_ENTT_ID_CAT_CTGR_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `catalog_category_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `CATALOG_CATEGORY_ENTITY_INT_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=3042 DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Category Integer Attribute Backend Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_category_entity_int`
--

LOCK TABLES `catalog_category_entity_int` WRITE;
/*!40000 ALTER TABLE `catalog_category_entity_int` DISABLE KEYS */;
INSERT INTO `catalog_category_entity_int` VALUES (1,69,0,1,1),(2,69,0,2,1),(3,46,0,2,1),(4,46,0,3,1),(5,54,0,3,1),(6,69,0,3,1),(7,70,0,3,1),(8,71,0,3,0),(9,46,0,4,1),(10,54,0,4,1),(11,69,0,4,1),(12,70,0,4,0),(13,71,0,4,0),(14,46,0,5,1),(15,54,0,5,1),(16,69,0,5,1),(17,70,0,5,0),(18,71,0,5,0),(19,46,0,6,1),(20,54,0,6,1),(21,69,0,6,1),(22,70,0,6,0),(23,71,0,6,0),(24,46,0,7,1),(25,54,0,7,1),(26,69,0,7,1),(27,70,0,7,0),(28,71,0,7,0),(29,46,0,8,1),(30,54,0,8,1),(31,69,0,8,1),(32,70,0,8,0),(33,71,0,8,0),(34,46,0,9,1),(35,54,0,9,1),(36,69,0,9,1),(37,70,0,9,0),(38,71,0,9,0),(39,46,0,10,0),(40,54,0,10,1),(41,69,0,10,0),(42,70,0,10,0),(43,71,0,10,0),(44,46,0,11,0),(45,54,0,11,1),(46,69,0,11,0),(47,70,0,11,0),(48,71,0,11,0),(49,46,0,12,1),(50,54,0,12,1),(51,69,0,12,1),(52,70,0,12,0),(53,71,0,12,0),(60,46,0,15,1),(61,54,0,15,1),(62,69,0,15,1),(63,70,0,15,0),(64,71,0,15,0),(65,53,0,15,NULL),(66,46,0,16,1),(67,54,0,16,1),(68,69,0,16,1),(69,70,0,16,0),(70,71,0,16,0),(71,46,0,17,1),(72,54,0,17,1),(73,69,0,17,1),(74,70,0,17,0),(75,71,0,17,0),(76,53,0,3,NULL),(77,46,0,18,1),(78,54,0,18,1),(79,69,0,18,1),(80,70,0,18,0),(81,71,0,18,0),(87,46,0,20,0),(88,54,0,20,1),(89,69,0,20,0),(90,70,0,20,0),(91,71,0,20,0),(92,46,0,21,0),(93,54,0,21,1),(94,69,0,21,0),(95,70,0,21,0),(96,71,0,21,0),(97,46,0,22,1),(98,54,0,22,1),(99,69,0,22,1),(100,70,0,22,0),(101,71,0,22,0),(102,46,0,23,0),(103,54,0,23,1),(104,69,0,23,0),(105,70,0,23,0),(106,71,0,23,0),(107,46,0,24,1),(108,54,0,24,1),(109,69,0,24,1),(110,70,0,24,0),(111,71,0,24,0),(112,46,0,25,1),(113,54,0,25,1),(114,69,0,25,1),(115,70,0,25,0),(116,71,0,25,0),(117,46,0,26,1),(118,54,0,26,1),(119,69,0,26,1),(120,70,0,26,0),(121,71,0,26,0),(122,46,0,27,1),(123,54,0,27,1),(124,69,0,27,1),(125,70,0,27,0),(126,71,0,27,0),(127,46,0,28,1),(128,54,0,28,1),(129,69,0,28,1),(130,70,0,28,0),(131,71,0,28,0),(132,46,0,29,0),(133,54,0,29,1),(134,69,0,29,0),(135,70,0,29,0),(136,71,0,29,0),(137,46,0,30,1),(138,54,0,30,1),(139,69,0,30,1),(140,70,0,30,0),(141,71,0,30,0),(142,46,0,31,1),(143,54,0,31,1),(144,69,0,31,1),(145,70,0,31,0),(146,71,0,31,0),(147,46,0,32,1),(148,54,0,32,1),(149,69,0,32,1),(150,70,0,32,0),(151,71,0,32,0),(152,46,0,33,1),(153,54,0,33,1),(154,69,0,33,1),(155,70,0,33,0),(156,71,0,33,0),(157,46,0,34,0),(158,54,0,34,1),(159,69,0,34,0),(160,70,0,34,0),(161,71,0,34,0),(162,46,0,35,0),(163,54,0,35,1),(164,69,0,35,0),(165,70,0,35,0),(166,71,0,35,0),(167,46,0,36,0),(168,54,0,36,1),(169,69,0,36,0),(170,70,0,36,0),(171,71,0,36,0),(172,46,0,37,1),(173,54,0,37,1),(174,69,0,37,1),(175,70,0,37,0),(176,71,0,37,0),(177,46,0,38,0),(178,54,0,38,1),(179,69,0,38,0),(180,70,0,38,0),(181,71,0,38,0),(182,46,0,39,1),(183,54,0,39,1),(184,69,0,39,1),(185,70,0,39,0),(186,71,0,39,0),(187,46,0,40,1),(188,54,0,40,1),(189,69,0,40,1),(190,70,0,40,0),(191,71,0,40,0),(192,46,0,41,1),(193,54,0,41,1),(194,69,0,41,1),(195,70,0,41,0),(196,71,0,41,0),(197,46,0,42,1),(198,54,0,42,1),(199,69,0,42,1),(200,70,0,42,0),(201,71,0,42,0),(202,46,0,43,1),(203,54,0,43,1),(204,69,0,43,1),(205,70,0,43,0),(206,71,0,43,0),(207,46,0,44,1),(208,54,0,44,1),(209,69,0,44,1),(210,70,0,44,0),(211,71,0,44,0),(212,46,0,45,1),(213,54,0,45,1),(214,69,0,45,1),(215,70,0,45,0),(216,71,0,45,0),(217,46,0,46,1),(218,54,0,46,1),(219,69,0,46,1),(220,70,0,46,0),(221,71,0,46,0),(222,46,0,47,1),(223,54,0,47,1),(224,69,0,47,1),(225,70,0,47,0),(226,71,0,47,0),(227,46,0,48,1),(228,54,0,48,1),(229,69,0,48,1),(230,70,0,48,0),(231,71,0,48,0),(232,46,0,49,1),(233,54,0,49,1),(234,69,0,49,1),(235,70,0,49,0),(236,71,0,49,0),(237,46,0,50,1),(238,54,0,50,1),(239,69,0,50,1),(240,70,0,50,0),(241,71,0,50,0),(242,46,0,51,0),(243,54,0,51,1),(244,69,0,51,0),(245,70,0,51,0),(246,71,0,51,0),(247,46,0,52,1),(248,54,0,52,1),(249,69,0,52,1),(250,70,0,52,0),(251,71,0,52,0),(252,46,0,53,1),(253,54,0,53,1),(254,69,0,53,1),(255,70,0,53,0),(256,71,0,53,0),(257,46,0,54,1),(258,54,0,54,1),(259,69,0,54,1),(260,70,0,54,0),(261,71,0,54,0),(262,46,0,55,1),(263,54,0,55,1),(264,69,0,55,1),(265,70,0,55,0),(266,71,0,55,0),(267,46,0,56,0),(268,54,0,56,1),(269,69,0,56,0),(270,70,0,56,0),(271,71,0,56,0),(272,46,0,57,0),(273,54,0,57,1),(274,69,0,57,0),(275,70,0,57,0),(276,71,0,57,0),(277,53,0,57,NULL),(278,46,0,58,1),(279,54,0,58,1),(280,69,0,58,1),(281,70,0,58,0),(282,71,0,58,0),(283,46,0,59,1),(284,54,0,59,1),(285,69,0,59,1),(286,70,0,59,0),(287,71,0,59,0),(288,46,0,60,1),(289,54,0,60,1),(290,69,0,60,1),(291,70,0,60,0),(292,71,0,60,0),(293,46,0,61,1),(294,54,0,61,1),(295,69,0,61,1),(296,70,0,61,0),(297,71,0,61,0),(298,46,0,62,0),(299,54,0,62,1),(300,69,0,62,0),(301,70,0,62,0),(302,71,0,62,0),(303,46,0,63,1),(304,54,0,63,1),(305,69,0,63,1),(306,70,0,63,0),(307,71,0,63,0),(308,46,0,64,1),(309,54,0,64,1),(310,69,0,64,1),(311,70,0,64,0),(312,71,0,64,0),(313,46,0,65,1),(314,54,0,65,1),(315,69,0,65,1),(316,70,0,65,0),(317,71,0,65,0),(318,53,0,4,NULL),(319,46,0,66,1),(320,54,0,66,1),(321,69,0,66,1),(322,70,0,66,0),(323,71,0,66,0),(324,46,0,67,1),(325,54,0,67,1),(326,69,0,67,1),(327,70,0,67,0),(328,71,0,67,0),(329,46,0,68,1),(330,54,0,68,1),(331,69,0,68,1),(332,70,0,68,0),(333,71,0,68,0),(334,46,0,69,1),(335,54,0,69,1),(336,69,0,69,1),(337,70,0,69,0),(338,71,0,69,0),(339,46,0,70,1),(340,54,0,70,1),(341,69,0,70,1),(342,70,0,70,0),(343,71,0,70,0),(344,46,0,71,1),(345,54,0,71,1),(346,69,0,71,1),(347,70,0,71,0),(348,71,0,71,0),(349,46,0,72,0),(350,54,0,72,1),(351,69,0,72,0),(352,70,0,72,0),(353,71,0,72,0),(354,46,0,73,0),(355,54,0,73,1),(356,69,0,73,0),(357,70,0,73,0),(358,71,0,73,0),(359,46,0,74,0),(360,54,0,74,1),(361,69,0,74,0),(362,70,0,74,0),(363,71,0,74,0),(364,46,0,75,0),(365,54,0,75,1),(366,69,0,75,0),(367,70,0,75,0),(368,71,0,75,0),(369,46,0,76,0),(370,54,0,76,1),(371,69,0,76,0),(372,70,0,76,0),(373,71,0,76,0),(374,46,0,77,0),(375,54,0,77,1),(376,69,0,77,0),(377,70,0,77,0),(378,71,0,77,0),(379,46,0,78,1),(380,54,0,78,1),(381,69,0,78,1),(382,70,0,78,0),(383,71,0,78,0),(384,46,0,79,1),(385,54,0,79,1),(386,69,0,79,1),(387,70,0,79,0),(388,71,0,79,0),(389,46,0,80,1),(390,54,0,80,1),(391,69,0,80,1),(392,70,0,80,0),(393,71,0,80,0),(394,46,0,81,1),(395,54,0,81,1),(396,69,0,81,1),(397,70,0,81,0),(398,71,0,81,0),(399,46,0,82,1),(400,54,0,82,1),(401,69,0,82,1),(402,70,0,82,0),(403,71,0,82,0),(404,46,0,83,1),(405,54,0,83,1),(406,69,0,83,1),(407,70,0,83,0),(408,71,0,83,0),(409,46,0,84,1),(410,54,0,84,1),(411,69,0,84,1),(412,70,0,84,0),(413,71,0,84,0),(414,46,0,85,1),(415,54,0,85,1),(416,69,0,85,1),(417,70,0,85,0),(418,71,0,85,0),(419,46,0,86,1),(420,54,0,86,1),(421,69,0,86,1),(422,70,0,86,0),(423,71,0,86,0),(424,53,0,5,NULL),(425,46,0,87,1),(426,54,0,87,1),(427,69,0,87,1),(428,70,0,87,0),(429,71,0,87,0),(430,46,0,88,1),(431,54,0,88,1),(432,69,0,88,1),(433,70,0,88,0),(434,71,0,88,0),(435,46,0,89,1),(436,54,0,89,1),(437,69,0,89,1),(438,70,0,89,0),(439,71,0,89,0),(440,46,0,90,1),(441,54,0,90,1),(442,69,0,90,1),(443,70,0,90,0),(444,71,0,90,0),(445,46,0,91,1),(446,54,0,91,1),(447,69,0,91,1),(448,70,0,91,0),(449,71,0,91,0),(450,46,0,92,1),(451,54,0,92,1),(452,69,0,92,1),(453,70,0,92,0),(454,71,0,92,0),(455,46,0,93,1),(456,54,0,93,1),(457,69,0,93,1),(458,70,0,93,0),(459,71,0,93,0),(460,46,0,94,1),(461,54,0,94,1),(462,69,0,94,1),(463,70,0,94,0),(464,71,0,94,0),(465,46,0,95,1),(466,54,0,95,1),(467,69,0,95,1),(468,70,0,95,0),(469,71,0,95,0),(470,46,0,96,1),(471,54,0,96,1),(472,69,0,96,1),(473,70,0,96,0),(474,71,0,96,0),(475,46,0,97,1),(476,54,0,97,1),(477,69,0,97,1),(478,70,0,97,0),(479,71,0,97,0),(480,53,0,97,NULL),(481,46,0,98,1),(482,54,0,98,1),(483,69,0,98,1),(484,70,0,98,0),(485,71,0,98,0),(486,46,0,99,1),(487,54,0,99,1),(488,69,0,99,1),(489,70,0,99,0),(490,71,0,99,0),(491,46,0,100,1),(492,54,0,100,1),(493,69,0,100,1),(494,70,0,100,0),(495,71,0,100,0),(496,46,0,101,1),(497,54,0,101,1),(498,69,0,101,1),(499,70,0,101,0),(500,71,0,101,0),(501,46,0,102,1),(502,54,0,102,1),(503,69,0,102,1),(504,70,0,102,0),(505,71,0,102,0),(506,46,0,103,1),(507,54,0,103,1),(508,69,0,103,1),(509,70,0,103,0),(510,71,0,103,0),(511,46,0,104,1),(512,54,0,104,1),(513,69,0,104,1),(514,70,0,104,0),(515,71,0,104,0),(516,46,0,105,1),(517,54,0,105,1),(518,69,0,105,1),(519,70,0,105,0),(520,71,0,105,0),(521,46,0,106,1),(522,54,0,106,1),(523,69,0,106,1),(524,70,0,106,0),(525,71,0,106,0),(526,46,0,107,0),(527,54,0,107,1),(528,69,0,107,0),(529,70,0,107,0),(530,71,0,107,0),(531,46,0,108,1),(532,54,0,108,1),(533,69,0,108,1),(534,70,0,108,0),(535,71,0,108,0),(536,46,0,109,0),(537,54,0,109,1),(538,69,0,109,0),(539,70,0,109,0),(540,71,0,109,0),(541,46,0,110,1),(542,54,0,110,1),(543,69,0,110,1),(544,70,0,110,0),(545,71,0,110,0),(546,53,0,37,NULL),(547,53,0,6,NULL),(548,46,0,111,1),(549,54,0,111,1),(550,69,0,111,1),(551,70,0,111,0),(552,71,0,111,0),(553,46,0,112,0),(554,54,0,112,1),(555,69,0,112,0),(556,70,0,112,0),(557,71,0,112,0),(558,46,0,113,1),(559,54,0,113,1),(560,69,0,113,1),(561,70,0,113,0),(562,71,0,113,0),(563,46,0,114,1),(564,54,0,114,1),(565,69,0,114,1),(566,70,0,114,0),(567,71,0,114,0),(568,46,0,115,1),(569,54,0,115,1),(570,69,0,115,1),(571,70,0,115,0),(572,71,0,115,0),(573,46,0,116,0),(574,54,0,116,1),(575,69,0,116,0),(576,70,0,116,0),(577,71,0,116,0),(578,46,0,117,1),(579,54,0,117,1),(580,69,0,117,1),(581,70,0,117,0),(582,71,0,117,0),(583,46,0,118,1),(584,54,0,118,1),(585,69,0,118,1),(586,70,0,118,0),(587,71,0,118,0),(588,46,0,119,1),(589,54,0,119,1),(590,69,0,119,1),(591,70,0,119,0),(592,71,0,119,0),(593,46,0,120,1),(594,54,0,120,1),(595,69,0,120,1),(596,70,0,120,0),(597,71,0,120,0),(598,46,0,121,1),(599,54,0,121,1),(600,69,0,121,1),(601,70,0,121,0),(602,71,0,121,0),(603,46,0,122,0),(604,54,0,122,1),(605,69,0,122,0),(606,70,0,122,0),(607,71,0,122,0),(608,46,0,123,1),(609,54,0,123,1),(610,69,0,123,1),(611,70,0,123,0),(612,71,0,123,0),(613,46,0,124,1),(614,54,0,124,1),(615,69,0,124,1),(616,70,0,124,0),(617,71,0,124,0),(618,46,0,125,1),(619,54,0,125,1),(620,69,0,125,1),(621,70,0,125,0),(622,71,0,125,0),(623,46,0,126,1),(624,54,0,126,1),(625,69,0,126,1),(626,70,0,126,0),(627,71,0,126,0),(628,46,0,127,0),(629,54,0,127,1),(630,69,0,127,0),(631,70,0,127,0),(632,71,0,127,0),(633,46,0,128,1),(634,54,0,128,1),(635,69,0,128,1),(636,70,0,128,0),(637,71,0,128,0),(638,46,0,129,1),(639,54,0,129,1),(640,69,0,129,1),(641,70,0,129,0),(642,71,0,129,0),(643,46,0,130,1),(644,54,0,130,1),(645,69,0,130,1),(646,70,0,130,0),(647,71,0,130,0),(653,46,0,132,1),(654,54,0,132,1),(655,69,0,132,1),(656,70,0,132,0),(657,71,0,132,0),(658,46,0,133,0),(659,54,0,133,1),(660,69,0,133,0),(661,70,0,133,0),(662,71,0,133,0),(663,46,0,134,0),(664,54,0,134,1),(665,69,0,134,0),(666,70,0,134,0),(667,71,0,134,0),(668,53,0,7,NULL),(669,46,0,135,1),(670,54,0,135,1),(671,69,0,135,1),(672,70,0,135,0),(673,71,0,135,0),(674,46,0,136,1),(675,54,0,136,1),(676,69,0,136,1),(677,70,0,136,0),(678,71,0,136,0),(679,46,0,137,1),(680,54,0,137,1),(681,69,0,137,1),(682,70,0,137,0),(683,71,0,137,0),(684,46,0,138,0),(685,54,0,138,1),(686,69,0,138,0),(687,70,0,138,0),(688,71,0,138,0),(689,46,0,139,1),(690,54,0,139,1),(691,69,0,139,1),(692,70,0,139,0),(693,71,0,139,0),(694,46,0,140,0),(695,54,0,140,1),(696,69,0,140,0),(697,70,0,140,0),(698,71,0,140,0),(699,46,0,141,0),(700,54,0,141,1),(701,69,0,141,0),(702,70,0,141,0),(703,71,0,141,0),(704,46,0,142,1),(705,54,0,142,1),(706,69,0,142,1),(707,70,0,142,0),(708,71,0,142,0),(709,46,0,143,1),(710,54,0,143,1),(711,69,0,143,1),(712,70,0,143,0),(713,71,0,143,0),(714,46,0,144,1),(715,54,0,144,1),(716,69,0,144,1),(717,70,0,144,0),(718,71,0,144,0),(719,53,0,8,NULL),(720,46,0,145,1),(721,54,0,145,1),(722,69,0,145,1),(723,70,0,145,0),(724,71,0,145,0),(725,46,0,146,0),(726,54,0,146,1),(727,69,0,146,0),(728,70,0,146,0),(729,71,0,146,0),(730,46,0,147,1),(731,54,0,147,1),(732,69,0,147,1),(733,70,0,147,0),(734,71,0,147,0),(735,46,0,148,1),(736,54,0,148,1),(737,69,0,148,1),(738,70,0,148,0),(739,71,0,148,0),(740,46,0,149,0),(741,54,0,149,1),(742,69,0,149,0),(743,70,0,149,0),(744,71,0,149,0),(745,46,0,150,0),(746,54,0,150,1),(747,69,0,150,0),(748,70,0,150,0),(749,71,0,150,0),(750,46,0,151,1),(751,54,0,151,1),(752,69,0,151,1),(753,70,0,151,0),(754,71,0,151,0),(755,46,0,152,1),(756,54,0,152,1),(757,69,0,152,1),(758,70,0,152,0),(759,71,0,152,0),(760,46,0,153,0),(761,54,0,153,1),(762,69,0,153,0),(763,70,0,153,0),(764,71,0,153,0),(765,46,0,154,1),(766,54,0,154,1),(767,69,0,154,1),(768,70,0,154,0),(769,71,0,154,0),(770,53,0,154,NULL),(771,46,0,155,1),(772,54,0,155,1),(773,69,0,155,1),(774,70,0,155,0),(775,71,0,155,0),(776,46,0,156,0),(777,54,0,156,1),(778,69,0,156,0),(779,70,0,156,0),(780,71,0,156,0),(781,46,0,157,0),(782,54,0,157,1),(783,69,0,157,0),(784,70,0,157,0),(785,71,0,157,0),(786,46,0,158,1),(787,54,0,158,1),(788,69,0,158,1),(789,70,0,158,0),(790,71,0,158,0),(791,46,0,159,1),(792,54,0,159,1),(793,69,0,159,1),(794,70,0,159,0),(795,71,0,159,0),(796,46,0,160,1),(797,54,0,160,1),(798,69,0,160,1),(799,70,0,160,0),(800,71,0,160,0),(801,46,0,161,1),(802,54,0,161,1),(803,69,0,161,1),(804,70,0,161,0),(805,71,0,161,0),(806,46,0,162,1),(807,54,0,162,1),(808,69,0,162,1),(809,70,0,162,0),(810,71,0,162,0),(811,53,0,9,NULL),(812,46,0,163,0),(813,54,0,163,1),(814,69,0,163,0),(815,70,0,163,0),(816,71,0,163,0),(817,53,0,163,NULL),(818,46,0,164,0),(819,54,0,164,1),(820,69,0,164,0),(821,70,0,164,0),(822,71,0,164,0),(823,53,0,16,NULL),(824,53,0,17,NULL),(825,53,0,18,NULL),(826,53,0,10,NULL),(827,53,0,11,NULL),(828,53,0,12,NULL),(832,53,0,164,NULL),(833,53,0,25,NULL),(834,53,0,46,NULL),(835,53,0,51,NULL),(836,53,0,54,NULL),(837,53,0,62,NULL),(838,53,0,21,NULL),(839,53,0,22,NULL),(840,53,0,23,NULL),(841,53,0,24,NULL),(842,53,0,26,NULL),(843,53,0,27,NULL),(844,53,0,28,NULL),(845,53,0,29,NULL),(846,53,0,30,NULL),(847,53,0,31,NULL),(848,53,0,2,NULL),(849,54,0,2,1),(850,70,0,2,0),(851,71,0,2,0),(852,53,0,32,NULL),(853,53,0,33,NULL),(854,53,0,34,NULL),(855,53,0,35,NULL),(856,53,0,36,NULL),(857,53,0,38,NULL),(858,53,0,39,NULL),(859,53,0,40,NULL),(860,53,0,41,NULL),(861,53,0,42,NULL),(862,53,0,43,NULL),(863,53,0,44,NULL),(864,53,0,45,NULL),(865,53,0,47,NULL),(866,53,0,48,NULL),(867,53,0,49,NULL),(868,53,0,50,NULL),(869,53,0,52,NULL),(870,53,0,53,NULL),(871,53,0,58,NULL),(872,53,0,59,NULL),(873,53,0,60,NULL),(874,53,0,61,NULL),(875,53,0,55,NULL),(876,53,0,56,NULL),(877,53,0,71,NULL),(878,53,0,72,NULL),(879,53,0,73,NULL),(880,53,0,74,NULL),(881,53,0,75,NULL),(882,53,0,76,NULL),(883,53,0,77,NULL),(884,53,0,78,NULL),(885,53,0,79,NULL),(886,53,0,80,NULL),(887,53,0,81,NULL),(888,53,0,83,NULL),(889,53,0,84,NULL),(890,53,0,85,NULL),(891,53,0,86,NULL),(892,53,0,67,NULL),(893,53,0,68,NULL),(894,53,0,69,NULL),(895,53,0,70,NULL),(896,53,0,87,NULL),(897,53,0,88,NULL),(898,53,0,89,NULL),(899,53,0,90,NULL),(900,53,0,91,NULL),(901,53,0,92,NULL),(902,53,0,94,NULL),(903,53,0,95,NULL),(904,53,0,93,NULL),(905,53,0,96,NULL),(906,53,0,98,NULL),(907,53,0,99,NULL),(908,53,0,100,NULL),(909,53,0,101,NULL),(910,53,0,102,NULL),(911,53,0,103,NULL),(912,53,0,104,NULL),(913,53,0,105,NULL),(914,53,0,106,NULL),(915,53,0,110,NULL),(916,53,0,108,NULL),(917,53,0,107,NULL),(918,53,0,111,NULL),(919,53,0,112,NULL),(920,53,0,113,NULL),(921,53,0,114,NULL),(922,53,0,115,NULL),(923,53,0,116,NULL),(924,53,0,117,NULL),(925,53,0,118,NULL),(926,53,0,123,NULL),(927,53,0,121,NULL),(928,53,0,122,NULL),(929,53,0,120,NULL),(930,53,0,119,NULL),(931,53,0,124,NULL),(932,53,0,125,NULL),(933,53,0,126,NULL),(934,53,0,127,NULL),(935,53,0,128,NULL),(936,53,0,129,NULL),(937,53,0,130,NULL),(939,53,0,132,NULL),(940,53,0,133,NULL),(941,53,0,134,NULL),(942,53,0,135,NULL),(943,53,0,140,NULL),(944,53,0,141,NULL),(945,53,0,139,NULL),(946,53,0,138,NULL),(947,53,0,137,NULL),(948,53,0,142,NULL),(949,53,0,143,NULL),(950,53,0,144,NULL),(951,53,0,136,NULL),(952,53,0,145,NULL),(953,53,0,146,NULL),(954,53,0,147,NULL),(955,53,0,149,NULL),(956,53,0,151,NULL),(957,53,0,152,NULL),(958,53,0,153,NULL),(959,53,0,155,NULL),(960,53,0,156,NULL),(961,53,0,157,NULL),(962,53,0,158,NULL),(963,53,0,159,NULL),(964,53,0,162,NULL),(965,53,0,161,NULL),(966,53,0,160,NULL),(967,53,0,150,NULL),(968,46,0,165,1),(969,54,0,165,1),(970,69,0,165,1),(971,70,0,165,0),(972,71,0,165,0),(973,46,0,166,1),(974,54,0,166,1),(975,69,0,166,1),(976,70,0,166,0),(977,71,0,166,0),(978,53,0,166,NULL),(979,46,0,167,1),(980,54,0,167,1),(981,69,0,167,1),(982,70,0,167,0),(983,71,0,167,0),(984,46,0,168,1),(985,54,0,168,1),(986,69,0,168,1),(987,70,0,168,0),(988,71,0,168,0),(989,46,0,169,1),(990,54,0,169,1),(991,69,0,169,1),(992,70,0,169,0),(993,71,0,169,0),(994,46,0,170,1),(995,54,0,170,1),(996,69,0,170,1),(997,70,0,170,0),(998,71,0,170,0),(999,53,0,165,NULL),(1000,46,0,171,1),(1001,54,0,171,1),(1002,69,0,171,1),(1003,70,0,171,0),(1004,71,0,171,0),(1005,46,0,172,1),(1006,54,0,172,1),(1007,69,0,172,1),(1008,70,0,172,0),(1009,71,0,172,0),(1010,46,0,173,0),(1011,54,0,173,1),(1012,69,0,173,0),(1013,70,0,173,0),(1014,71,0,173,0),(1015,46,0,174,0),(1016,54,0,174,1),(1017,69,0,174,0),(1018,70,0,174,0),(1019,71,0,174,0),(1020,53,0,167,NULL),(1021,46,0,175,0),(1022,54,0,175,1),(1023,69,0,175,0),(1024,70,0,175,0),(1025,71,0,175,0),(1026,46,0,176,1),(1027,54,0,176,1),(1028,69,0,176,1),(1029,70,0,176,0),(1030,71,0,176,0),(1031,53,0,169,NULL),(1032,46,0,177,1),(1033,54,0,177,1),(1034,69,0,177,1),(1035,70,0,177,0),(1036,71,0,177,0),(1037,53,0,175,NULL),(1038,46,0,178,1),(1039,54,0,178,1),(1040,69,0,178,1),(1041,70,0,178,0),(1042,71,0,178,0),(1043,46,0,179,1),(1044,54,0,179,1),(1045,69,0,179,1),(1046,70,0,179,0),(1047,71,0,179,0),(1048,53,0,176,NULL),(1049,53,0,177,NULL),(1050,46,0,180,1),(1051,54,0,180,1),(1052,69,0,180,1),(1053,70,0,180,0),(1054,71,0,180,0),(1055,46,0,181,1),(1056,54,0,181,1),(1057,69,0,181,1),(1058,70,0,181,0),(1059,71,0,181,0),(1060,53,0,178,NULL),(1061,53,0,179,NULL),(1062,53,0,180,NULL),(1063,53,0,181,NULL),(1064,53,0,171,NULL),(1065,53,0,172,NULL),(1066,53,0,173,NULL),(1067,53,0,174,NULL),(1068,46,0,182,1),(1069,54,0,182,1),(1070,69,0,182,1),(1071,70,0,182,0),(1072,71,0,182,0),(1073,46,0,183,0),(1074,54,0,183,1),(1075,69,0,183,0),(1076,70,0,183,0),(1077,71,0,183,0),(1078,46,0,184,0),(1079,54,0,184,1),(1080,69,0,184,0),(1081,70,0,184,0),(1082,71,0,184,0),(1083,46,0,185,0),(1084,54,0,185,1),(1085,69,0,185,0),(1086,70,0,185,0),(1087,71,0,185,0),(1088,53,0,182,NULL),(1089,53,0,183,NULL),(1090,53,0,184,NULL),(1091,46,0,186,0),(1092,54,0,186,1),(1093,69,0,186,0),(1094,70,0,186,0),(1095,71,0,186,0),(1096,53,0,185,NULL),(1097,46,0,187,1),(1098,54,0,187,1),(1099,69,0,187,1),(1100,70,0,187,0),(1101,71,0,187,0),(1102,53,0,186,NULL),(1103,46,0,188,0),(1104,54,0,188,1),(1105,69,0,188,0),(1106,70,0,188,0),(1107,71,0,188,0),(1108,46,0,189,0),(1109,54,0,189,1),(1110,69,0,189,0),(1111,70,0,189,0),(1112,71,0,189,0),(1113,46,0,190,1),(1114,54,0,190,1),(1115,69,0,190,1),(1116,70,0,190,0),(1117,71,0,190,0),(1118,46,0,191,1),(1119,54,0,191,1),(1120,69,0,191,1),(1121,70,0,191,0),(1122,71,0,191,0),(1123,46,0,192,1),(1124,54,0,192,1),(1125,69,0,192,1),(1126,70,0,192,0),(1127,71,0,192,0),(1128,46,0,193,1),(1129,54,0,193,1),(1130,69,0,193,1),(1131,70,0,193,0),(1132,71,0,193,0),(1133,46,0,194,1),(1134,54,0,194,1),(1135,69,0,194,1),(1136,70,0,194,0),(1137,71,0,194,0),(1138,46,0,195,1),(1139,54,0,195,1),(1140,69,0,195,1),(1141,70,0,195,0),(1142,71,0,195,0),(1143,46,0,196,1),(1144,54,0,196,1),(1145,69,0,196,1),(1146,70,0,196,0),(1147,71,0,196,0),(1148,53,0,187,NULL),(1149,46,0,197,1),(1150,54,0,197,1),(1151,69,0,197,1),(1152,70,0,197,0),(1153,71,0,197,0),(1154,53,0,189,NULL),(1155,53,0,190,NULL),(1156,53,0,188,NULL),(1157,53,0,191,NULL),(1158,53,0,192,NULL),(1159,53,0,193,NULL),(1160,53,0,194,NULL),(1161,53,0,195,NULL),(1162,53,0,196,NULL),(1163,53,0,197,NULL),(1164,151,0,130,0),(1165,151,0,3,0),(1166,53,0,20,NULL),(1167,151,0,20,0),(1168,151,0,21,0),(1169,151,0,23,0),(1170,46,0,198,1),(1171,54,0,198,1),(1172,69,0,198,1),(1173,70,0,198,0),(1174,71,0,198,0),(1175,151,0,198,0),(1176,46,0,199,1),(1177,54,0,199,1),(1178,69,0,199,1),(1179,70,0,199,0),(1180,71,0,199,0),(1181,151,0,199,0),(1182,53,0,199,NULL),(1183,46,0,200,1),(1184,54,0,200,1),(1185,69,0,200,1),(1186,70,0,200,0),(1187,71,0,200,0),(1188,151,0,200,0),(1189,46,0,201,1),(1190,54,0,201,1),(1191,69,0,201,1),(1192,70,0,201,0),(1193,71,0,201,0),(1194,151,0,201,0),(1195,46,0,202,1),(1196,54,0,202,1),(1197,69,0,202,1),(1198,70,0,202,0),(1199,71,0,202,0),(1200,151,0,202,0),(1201,46,0,203,1),(1202,54,0,203,1),(1203,69,0,203,1),(1204,70,0,203,0),(1205,71,0,203,0),(1206,151,0,203,0),(1207,46,0,204,1),(1208,54,0,204,1),(1209,69,0,204,1),(1210,70,0,204,0),(1211,71,0,204,0),(1212,151,0,204,0),(1213,46,0,205,1),(1214,54,0,205,1),(1215,69,0,205,1),(1216,70,0,205,0),(1217,71,0,205,0),(1218,151,0,205,0),(1232,46,0,208,1),(1233,54,0,208,1),(1234,69,0,208,1),(1235,70,0,208,0),(1236,71,0,208,0),(1237,151,0,208,0),(1238,46,0,209,1),(1239,54,0,209,1),(1240,69,0,209,1),(1241,70,0,209,0),(1242,71,0,209,0),(1243,151,0,209,0),(1244,46,0,210,1),(1245,54,0,210,1),(1246,69,0,210,1),(1247,70,0,210,0),(1248,71,0,210,0),(1249,151,0,210,0),(1250,46,0,211,1),(1251,54,0,211,1),(1252,69,0,211,1),(1253,70,0,211,0),(1254,71,0,211,0),(1255,151,0,211,0),(1256,46,0,212,1),(1257,54,0,212,1),(1258,69,0,212,1),(1259,70,0,212,0),(1260,71,0,212,0),(1261,151,0,212,0),(1262,46,0,213,1),(1263,54,0,213,1),(1264,69,0,213,1),(1265,70,0,213,0),(1266,71,0,213,0),(1267,151,0,213,0),(1268,46,0,214,1),(1269,54,0,214,1),(1270,69,0,214,1),(1271,70,0,214,0),(1272,71,0,214,0),(1273,151,0,214,0),(1274,46,0,215,1),(1275,54,0,215,1),(1276,69,0,215,1),(1277,70,0,215,0),(1278,71,0,215,0),(1279,151,0,215,0),(1280,46,0,216,1),(1281,54,0,216,1),(1282,69,0,216,1),(1283,70,0,216,0),(1284,71,0,216,0),(1285,151,0,216,0),(1298,46,0,219,1),(1299,54,0,219,1),(1300,69,0,219,1),(1301,70,0,219,0),(1302,71,0,219,0),(1303,151,0,219,0),(1310,151,0,25,0),(1311,151,0,26,0),(1312,46,0,221,1),(1313,54,0,221,1),(1314,69,0,221,1),(1315,70,0,221,0),(1316,71,0,221,0),(1317,151,0,221,0),(1318,46,0,222,1),(1319,54,0,222,1),(1320,69,0,222,1),(1321,70,0,222,0),(1322,71,0,222,0),(1323,151,0,222,0),(1324,46,0,223,1),(1325,54,0,223,1),(1326,69,0,223,1),(1327,70,0,223,0),(1328,71,0,223,0),(1329,151,0,223,0),(1330,46,0,224,1),(1331,54,0,224,1),(1332,69,0,224,1),(1333,70,0,224,0),(1334,71,0,224,0),(1335,151,0,224,0),(1336,46,0,225,1),(1337,54,0,225,1),(1338,69,0,225,1),(1339,70,0,225,0),(1340,71,0,225,0),(1341,151,0,225,0),(1342,151,0,29,0),(1343,151,0,34,0),(1344,151,0,35,0),(1345,151,0,36,0),(1346,46,0,226,1),(1347,54,0,226,1),(1348,69,0,226,1),(1349,70,0,226,0),(1350,71,0,226,0),(1351,151,0,226,0),(1352,46,0,227,1),(1353,54,0,227,1),(1354,69,0,227,1),(1355,70,0,227,0),(1356,71,0,227,0),(1357,151,0,227,0),(1364,46,0,229,1),(1365,54,0,229,1),(1366,69,0,229,1),(1367,70,0,229,0),(1368,71,0,229,0),(1369,151,0,229,0),(1370,46,0,230,1),(1371,54,0,230,1),(1372,69,0,230,1),(1373,70,0,230,0),(1374,71,0,230,0),(1375,151,0,230,0),(1376,46,0,231,1),(1377,54,0,231,1),(1378,69,0,231,1),(1379,70,0,231,0),(1380,71,0,231,0),(1381,151,0,231,0),(1382,46,0,232,1),(1383,54,0,232,1),(1384,69,0,232,1),(1385,70,0,232,0),(1386,71,0,232,0),(1387,151,0,232,0),(1388,46,0,233,1),(1389,54,0,233,1),(1390,69,0,233,1),(1391,70,0,233,0),(1392,71,0,233,0),(1393,151,0,233,0),(1394,46,0,234,1),(1395,54,0,234,1),(1396,69,0,234,1),(1397,70,0,234,0),(1398,71,0,234,0),(1399,151,0,234,0),(1400,46,0,235,1),(1401,54,0,235,1),(1402,69,0,235,1),(1403,70,0,235,0),(1404,71,0,235,0),(1405,151,0,235,0),(1406,46,0,236,1),(1407,54,0,236,1),(1408,69,0,236,1),(1409,70,0,236,0),(1410,71,0,236,0),(1411,151,0,236,0),(1412,46,0,237,1),(1413,54,0,237,1),(1414,69,0,237,1),(1415,70,0,237,0),(1416,71,0,237,0),(1417,151,0,237,0),(1418,151,0,165,0),(1419,151,0,166,0),(1420,53,0,168,NULL),(1421,151,0,168,0),(1422,46,0,238,1),(1423,54,0,238,1),(1424,69,0,238,1),(1425,70,0,238,0),(1426,71,0,238,0),(1427,151,0,238,0),(1428,151,0,173,0),(1429,151,0,174,0),(1430,46,0,239,1),(1431,54,0,239,1),(1432,69,0,239,1),(1433,70,0,239,0),(1434,71,0,239,0),(1435,151,0,239,0),(1436,151,0,169,0),(1437,151,0,175,0),(1438,151,0,181,0),(1439,46,0,240,1),(1440,54,0,240,1),(1441,69,0,240,1),(1442,70,0,240,0),(1443,71,0,240,0),(1444,151,0,240,0),(1445,46,0,241,1),(1446,54,0,241,1),(1447,69,0,241,1),(1448,70,0,241,0),(1449,71,0,241,0),(1450,151,0,241,0),(1451,46,0,242,1),(1452,54,0,242,1),(1453,69,0,242,1),(1454,70,0,242,0),(1455,71,0,242,0),(1456,151,0,242,0),(1457,46,0,243,1),(1458,54,0,243,1),(1459,69,0,243,1),(1460,70,0,243,0),(1461,71,0,243,0),(1462,151,0,243,0),(1463,46,0,244,1),(1464,54,0,244,1),(1465,69,0,244,1),(1466,70,0,244,0),(1467,71,0,244,0),(1468,151,0,244,0),(1469,151,0,78,0),(1470,151,0,79,0),(1471,53,0,219,NULL),(1472,151,0,4,0),(1473,46,0,245,1),(1474,54,0,245,1),(1475,69,0,245,1),(1476,70,0,245,0),(1477,71,0,245,0),(1478,151,0,245,0),(1479,46,0,246,1),(1480,54,0,246,1),(1481,69,0,246,1),(1482,70,0,246,0),(1483,71,0,246,0),(1484,151,0,246,0),(1485,151,0,80,0),(1486,151,0,72,0),(1487,151,0,73,0),(1488,151,0,74,0),(1489,151,0,75,0),(1490,151,0,76,0),(1491,151,0,77,0),(1492,151,0,67,0),(1493,151,0,68,0),(1494,53,0,82,NULL),(1495,151,0,82,0),(1496,151,0,83,0),(1497,151,0,84,0),(1498,151,0,85,0),(1499,151,0,86,0),(1500,46,0,247,1),(1501,54,0,247,1),(1502,69,0,247,1),(1503,70,0,247,0),(1504,71,0,247,0),(1505,151,0,247,0),(1506,46,0,248,1),(1507,54,0,248,1),(1508,69,0,248,1),(1509,70,0,248,0),(1510,71,0,248,0),(1511,151,0,248,0),(1512,46,0,249,1),(1513,54,0,249,1),(1514,69,0,249,1),(1515,70,0,249,0),(1516,71,0,249,0),(1517,151,0,249,0),(1518,46,0,250,1),(1519,54,0,250,1),(1520,69,0,250,1),(1521,70,0,250,0),(1522,71,0,250,0),(1523,151,0,250,0),(1524,46,0,251,1),(1525,54,0,251,1),(1526,69,0,251,1),(1527,70,0,251,0),(1528,71,0,251,0),(1529,151,0,251,0),(1530,46,0,252,1),(1531,54,0,252,1),(1532,69,0,252,1),(1533,70,0,252,0),(1534,71,0,252,0),(1535,151,0,252,0),(1536,46,0,253,1),(1537,54,0,253,1),(1538,69,0,253,1),(1539,70,0,253,0),(1540,71,0,253,0),(1541,151,0,253,0),(1542,46,0,254,1),(1543,54,0,254,1),(1544,69,0,254,1),(1545,70,0,254,0),(1546,71,0,254,0),(1547,151,0,254,0),(1548,46,0,255,1),(1549,54,0,255,1),(1550,69,0,255,1),(1551,70,0,255,0),(1552,71,0,255,0),(1553,151,0,255,0),(1554,46,0,256,1),(1555,54,0,256,1),(1556,69,0,256,1),(1557,70,0,256,0),(1558,71,0,256,0),(1559,151,0,256,0),(1560,46,0,257,1),(1561,54,0,257,1),(1562,69,0,257,1),(1563,70,0,257,0),(1564,71,0,257,0),(1565,151,0,257,0),(1566,151,0,38,0),(1567,151,0,182,0),(1568,46,0,258,1),(1569,54,0,258,1),(1570,69,0,258,1),(1571,70,0,258,0),(1572,71,0,258,0),(1573,151,0,258,0),(1574,151,0,45,0),(1575,46,0,259,1),(1576,54,0,259,1),(1577,69,0,259,1),(1578,70,0,259,0),(1579,71,0,259,0),(1580,151,0,259,0),(1581,46,0,260,1),(1582,54,0,260,1),(1583,69,0,260,1),(1584,70,0,260,0),(1585,71,0,260,0),(1586,151,0,260,0),(1587,46,0,261,1),(1588,54,0,261,1),(1589,69,0,261,1),(1590,70,0,261,0),(1591,71,0,261,0),(1592,151,0,261,0),(1593,151,0,183,0),(1594,151,0,184,0),(1595,151,0,185,0),(1596,151,0,186,0),(1597,151,0,188,0),(1598,151,0,189,0),(1599,46,0,262,1),(1600,54,0,262,1),(1601,69,0,262,1),(1602,70,0,262,0),(1603,71,0,262,0),(1604,151,0,262,0),(1605,53,0,262,NULL),(1606,46,0,263,1),(1607,54,0,263,1),(1608,69,0,263,1),(1609,70,0,263,0),(1610,71,0,263,0),(1611,151,0,263,0),(1612,46,0,264,1),(1613,54,0,264,1),(1614,69,0,264,1),(1615,70,0,264,0),(1616,71,0,264,0),(1617,151,0,264,0),(1618,46,0,265,1),(1619,54,0,265,1),(1620,69,0,265,1),(1621,70,0,265,0),(1622,71,0,265,0),(1623,151,0,265,0),(1624,46,0,266,1),(1625,54,0,266,1),(1626,69,0,266,1),(1627,70,0,266,0),(1628,71,0,266,0),(1629,151,0,266,0),(1630,46,0,267,1),(1631,54,0,267,1),(1632,69,0,267,1),(1633,70,0,267,0),(1634,71,0,267,0),(1635,151,0,267,0),(1636,46,0,268,1),(1637,54,0,268,1),(1638,69,0,268,1),(1639,70,0,268,0),(1640,71,0,268,0),(1641,151,0,268,0),(1642,46,0,269,1),(1643,54,0,269,1),(1644,69,0,269,1),(1645,70,0,269,0),(1646,71,0,269,0),(1647,151,0,269,0),(1648,46,0,270,1),(1649,54,0,270,1),(1650,69,0,270,1),(1651,70,0,270,0),(1652,71,0,270,0),(1653,151,0,270,0),(1654,46,0,271,1),(1655,54,0,271,1),(1656,69,0,271,1),(1657,70,0,271,0),(1658,71,0,271,0),(1659,151,0,271,0),(1660,46,0,272,1),(1661,54,0,272,1),(1662,69,0,272,1),(1663,70,0,272,0),(1664,71,0,272,0),(1665,151,0,272,0),(1666,46,0,273,1),(1667,54,0,273,1),(1668,69,0,273,1),(1669,70,0,273,0),(1670,71,0,273,0),(1671,151,0,273,0),(1672,46,0,274,1),(1673,54,0,274,1),(1674,69,0,274,1),(1675,70,0,274,0),(1676,71,0,274,0),(1677,151,0,274,0),(1678,46,0,275,1),(1679,54,0,275,1),(1680,69,0,275,1),(1681,70,0,275,0),(1682,71,0,275,0),(1683,151,0,275,0),(1684,151,0,151,0),(1685,46,0,276,1),(1686,54,0,276,1),(1687,69,0,276,1),(1688,70,0,276,0),(1689,71,0,276,0),(1690,151,0,276,0),(1691,46,0,277,1),(1692,54,0,277,1),(1693,69,0,277,1),(1694,70,0,277,0),(1695,71,0,277,0),(1696,151,0,277,0),(1697,46,0,278,1),(1698,54,0,278,1),(1699,69,0,278,1),(1700,70,0,278,0),(1701,71,0,278,0),(1702,151,0,278,0),(1703,151,0,154,0),(1704,46,0,279,1),(1705,54,0,279,1),(1706,69,0,279,1),(1707,70,0,279,0),(1708,71,0,279,0),(1709,151,0,279,0),(1710,46,0,280,1),(1711,54,0,280,1),(1712,69,0,280,1),(1713,70,0,280,0),(1714,71,0,280,0),(1715,151,0,280,0),(1722,46,0,282,1),(1723,54,0,282,1),(1724,69,0,282,1),(1725,70,0,282,0),(1726,71,0,282,0),(1727,151,0,282,0),(1728,151,0,153,0),(1729,151,0,156,0),(1730,151,0,157,0),(1731,151,0,150,0),(1732,151,0,54,0),(1733,151,0,55,0),(1734,46,0,283,1),(1735,54,0,283,1),(1736,69,0,283,1),(1737,70,0,283,0),(1738,71,0,283,0),(1739,151,0,283,0),(1740,46,0,284,1),(1741,54,0,284,1),(1742,69,0,284,1),(1743,70,0,284,0),(1744,71,0,284,0),(1745,151,0,284,0),(1746,46,0,285,1),(1747,54,0,285,1),(1748,69,0,285,1),(1749,70,0,285,0),(1750,71,0,285,0),(1751,151,0,285,0),(1752,46,0,286,1),(1753,54,0,286,1),(1754,69,0,286,1),(1755,70,0,286,0),(1756,71,0,286,0),(1757,151,0,286,0),(1758,46,0,287,1),(1759,54,0,287,1),(1760,69,0,287,1),(1761,70,0,287,0),(1762,71,0,287,0),(1763,151,0,287,0),(1764,46,0,288,1),(1765,54,0,288,1),(1766,69,0,288,1),(1767,70,0,288,0),(1768,71,0,288,0),(1769,151,0,288,0),(1770,46,0,289,1),(1771,54,0,289,1),(1772,69,0,289,1),(1773,70,0,289,0),(1774,71,0,289,0),(1775,151,0,289,0),(1776,46,0,290,1),(1777,54,0,290,1),(1778,69,0,290,1),(1779,70,0,290,0),(1780,71,0,290,0),(1781,151,0,290,0),(1782,46,0,291,1),(1783,54,0,291,1),(1784,69,0,291,1),(1785,70,0,291,0),(1786,71,0,291,0),(1787,151,0,291,0),(1788,46,0,292,1),(1789,54,0,292,1),(1790,69,0,292,1),(1791,70,0,292,0),(1792,71,0,292,0),(1793,151,0,292,0),(1794,46,0,293,1),(1795,54,0,293,1),(1796,69,0,293,1),(1797,70,0,293,0),(1798,71,0,293,0),(1799,151,0,293,0),(1800,46,0,294,1),(1801,54,0,294,1),(1802,69,0,294,1),(1803,70,0,294,0),(1804,71,0,294,0),(1805,151,0,294,0),(1806,151,0,56,0),(1807,46,0,295,1),(1808,54,0,295,1),(1809,69,0,295,1),(1810,70,0,295,0),(1811,71,0,295,0),(1812,151,0,295,0),(1813,151,0,47,0),(1814,151,0,48,0),(1815,151,0,49,0),(1816,46,0,296,1),(1817,54,0,296,1),(1818,69,0,296,1),(1819,70,0,296,0),(1820,71,0,296,0),(1821,151,0,296,0),(1822,46,0,297,1),(1823,54,0,297,1),(1824,69,0,297,1),(1825,70,0,297,0),(1826,71,0,297,0),(1827,151,0,297,0),(1828,46,0,298,1),(1829,54,0,298,1),(1830,69,0,298,1),(1831,70,0,298,0),(1832,71,0,298,0),(1833,151,0,298,0),(1834,46,0,299,1),(1835,54,0,299,1),(1836,69,0,299,1),(1837,70,0,299,0),(1838,71,0,299,0),(1839,151,0,299,0),(1840,46,0,300,1),(1841,54,0,300,1),(1842,69,0,300,1),(1843,70,0,300,0),(1844,71,0,300,0),(1845,151,0,300,0),(1846,46,0,301,1),(1847,54,0,301,1),(1848,69,0,301,1),(1849,70,0,301,0),(1850,71,0,301,0),(1851,151,0,301,0),(1852,46,0,302,1),(1853,54,0,302,1),(1854,69,0,302,1),(1855,70,0,302,0),(1856,71,0,302,0),(1857,151,0,302,0),(1858,46,0,303,1),(1859,54,0,303,1),(1860,69,0,303,1),(1861,70,0,303,0),(1862,71,0,303,0),(1863,151,0,303,0),(1864,46,0,304,1),(1865,54,0,304,1),(1866,69,0,304,1),(1867,70,0,304,0),(1868,71,0,304,0),(1869,151,0,304,0),(1870,46,0,305,1),(1871,54,0,305,1),(1872,69,0,305,1),(1873,70,0,305,0),(1874,71,0,305,0),(1875,151,0,305,0),(1876,46,0,306,1),(1877,54,0,306,1),(1878,69,0,306,1),(1879,70,0,306,0),(1880,71,0,306,0),(1881,151,0,306,0),(1882,53,0,290,NULL),(1883,151,0,62,0),(1884,151,0,57,0),(1885,151,0,51,0),(1886,151,0,5,0),(1887,46,0,307,1),(1888,54,0,307,1),(1889,69,0,307,1),(1890,70,0,307,0),(1891,71,0,307,0),(1892,151,0,307,0),(1893,46,0,308,1),(1894,54,0,308,1),(1895,69,0,308,1),(1896,70,0,308,0),(1897,71,0,308,0),(1898,151,0,308,0),(1899,46,0,309,1),(1900,54,0,309,1),(1901,69,0,309,1),(1902,70,0,309,0),(1903,71,0,309,0),(1904,151,0,309,0),(1905,46,0,310,1),(1906,54,0,310,1),(1907,69,0,310,1),(1908,70,0,310,0),(1909,71,0,310,0),(1910,151,0,310,0),(1911,46,0,311,1),(1912,54,0,311,1),(1913,69,0,311,1),(1914,70,0,311,0),(1915,71,0,311,0),(1916,151,0,311,0),(1917,46,0,312,1),(1918,54,0,312,1),(1919,69,0,312,1),(1920,70,0,312,0),(1921,71,0,312,0),(1922,151,0,312,0),(1923,151,0,107,0),(1924,53,0,109,NULL),(1925,151,0,109,0),(1926,151,0,106,0),(1927,46,0,313,1),(1928,54,0,313,1),(1929,69,0,313,1),(1930,70,0,313,0),(1931,71,0,313,0),(1932,151,0,313,0),(1933,46,0,314,1),(1934,54,0,314,1),(1935,69,0,314,1),(1936,70,0,314,0),(1937,71,0,314,0),(1938,151,0,314,0),(1939,46,0,315,1),(1940,54,0,315,1),(1941,69,0,315,1),(1942,70,0,315,0),(1943,71,0,315,0),(1944,151,0,315,0),(1945,46,0,316,1),(1946,54,0,316,1),(1947,69,0,316,1),(1948,70,0,316,0),(1949,71,0,316,0),(1950,151,0,316,0),(1951,46,0,317,1),(1952,54,0,317,1),(1953,69,0,317,1),(1954,70,0,317,0),(1955,71,0,317,0),(1956,151,0,317,0),(1957,46,0,318,1),(1958,54,0,318,1),(1959,69,0,318,1),(1960,70,0,318,0),(1961,71,0,318,0),(1962,151,0,318,0),(1963,53,0,318,NULL),(1964,46,0,319,1),(1965,54,0,319,1),(1966,69,0,319,1),(1967,70,0,319,0),(1968,71,0,319,0),(1969,151,0,319,0),(1976,46,0,321,1),(1977,54,0,321,1),(1978,69,0,321,1),(1979,70,0,321,0),(1980,71,0,321,0),(1981,151,0,321,0),(1982,46,0,322,1),(1983,54,0,322,1),(1984,69,0,322,1),(1985,70,0,322,0),(1986,71,0,322,0),(1987,151,0,322,0),(1988,46,0,323,1),(1989,54,0,323,1),(1990,69,0,323,1),(1991,70,0,323,0),(1992,71,0,323,0),(1993,151,0,323,0),(1994,46,0,324,1),(1995,54,0,324,1),(1996,69,0,324,1),(1997,70,0,324,0),(1998,71,0,324,0),(1999,151,0,324,0),(2000,46,0,325,1),(2001,54,0,325,1),(2002,69,0,325,1),(2003,70,0,325,0),(2004,71,0,325,0),(2005,151,0,325,0),(2006,46,0,326,1),(2007,54,0,326,1),(2008,69,0,326,1),(2009,70,0,326,0),(2010,71,0,326,0),(2011,151,0,326,0),(2012,46,0,327,1),(2013,54,0,327,1),(2014,69,0,327,1),(2015,70,0,327,0),(2016,71,0,327,0),(2017,151,0,327,0),(2018,46,0,328,1),(2019,54,0,328,1),(2020,69,0,328,1),(2021,70,0,328,0),(2022,71,0,328,0),(2023,151,0,328,0),(2024,46,0,329,1),(2025,54,0,329,1),(2026,69,0,329,1),(2027,70,0,329,0),(2028,71,0,329,0),(2029,151,0,329,0),(2030,151,0,110,0),(2031,46,0,330,1),(2032,54,0,330,1),(2033,69,0,330,1),(2034,70,0,330,0),(2035,71,0,330,0),(2036,151,0,330,0),(2037,46,0,331,1),(2038,54,0,331,1),(2039,69,0,331,1),(2040,70,0,331,0),(2041,71,0,331,0),(2042,151,0,331,0),(2043,46,0,332,1),(2044,54,0,332,1),(2045,69,0,332,1),(2046,70,0,332,0),(2047,71,0,332,0),(2048,151,0,332,0),(2061,46,0,335,1),(2062,54,0,335,1),(2063,69,0,335,1),(2064,70,0,335,0),(2065,71,0,335,0),(2066,151,0,335,0),(2067,46,0,336,1),(2068,54,0,336,1),(2069,69,0,336,1),(2070,70,0,336,0),(2071,71,0,336,0),(2072,151,0,336,0),(2073,151,0,146,0),(2074,151,0,147,0),(2075,53,0,148,NULL),(2076,151,0,148,0),(2077,151,0,149,0),(2078,151,0,87,0),(2079,151,0,96,0),(2080,46,0,337,1),(2081,54,0,337,1),(2082,69,0,337,1),(2083,70,0,337,0),(2084,71,0,337,0),(2085,151,0,337,0),(2086,46,0,338,1),(2087,54,0,338,1),(2088,69,0,338,1),(2089,70,0,338,0),(2090,71,0,338,0),(2091,151,0,338,0),(2092,46,0,339,1),(2093,54,0,339,1),(2094,69,0,339,1),(2095,70,0,339,0),(2096,71,0,339,0),(2097,151,0,339,0),(2098,46,0,340,1),(2099,54,0,340,1),(2100,69,0,340,1),(2101,70,0,340,0),(2102,71,0,340,0),(2103,151,0,340,0),(2104,46,0,341,1),(2105,54,0,341,1),(2106,69,0,341,1),(2107,70,0,341,0),(2108,71,0,341,0),(2109,151,0,341,0),(2110,46,0,342,1),(2111,54,0,342,1),(2112,69,0,342,1),(2113,70,0,342,0),(2114,71,0,342,0),(2115,151,0,342,0),(2116,46,0,343,1),(2117,54,0,343,1),(2118,69,0,343,1),(2119,70,0,343,0),(2120,71,0,343,0),(2121,151,0,343,0),(2122,46,0,344,1),(2123,54,0,344,1),(2124,69,0,344,1),(2125,70,0,344,0),(2126,71,0,344,0),(2127,151,0,344,0),(2128,46,0,345,1),(2129,54,0,345,1),(2130,69,0,345,1),(2131,70,0,345,0),(2132,71,0,345,0),(2133,151,0,345,0),(2134,46,0,346,1),(2135,54,0,346,1),(2136,69,0,346,1),(2137,70,0,346,0),(2138,71,0,346,0),(2139,151,0,346,0),(2140,46,0,347,1),(2141,54,0,347,1),(2142,69,0,347,1),(2143,70,0,347,0),(2144,71,0,347,0),(2145,151,0,347,0),(2146,46,0,348,1),(2147,54,0,348,1),(2148,69,0,348,1),(2149,70,0,348,0),(2150,71,0,348,0),(2151,151,0,348,0),(2152,46,0,349,1),(2153,54,0,349,1),(2154,69,0,349,1),(2155,70,0,349,0),(2156,71,0,349,0),(2157,151,0,349,0),(2158,46,0,350,1),(2159,54,0,350,1),(2160,69,0,350,1),(2161,70,0,350,0),(2162,71,0,350,0),(2163,151,0,350,0),(2164,46,0,351,1),(2165,54,0,351,1),(2166,69,0,351,1),(2167,70,0,351,0),(2168,71,0,351,0),(2169,151,0,351,0),(2170,46,0,352,1),(2171,54,0,352,1),(2172,69,0,352,1),(2173,70,0,352,0),(2174,71,0,352,0),(2175,151,0,352,0),(2176,46,0,353,1),(2177,54,0,353,1),(2178,69,0,353,1),(2179,70,0,353,0),(2180,71,0,353,0),(2181,151,0,353,0),(2182,46,0,354,1),(2183,54,0,354,1),(2184,69,0,354,1),(2185,70,0,354,0),(2186,71,0,354,0),(2187,151,0,354,0),(2188,46,0,355,1),(2189,54,0,355,1),(2190,69,0,355,1),(2191,70,0,355,0),(2192,71,0,355,0),(2193,151,0,355,0),(2194,46,0,356,1),(2195,54,0,356,1),(2196,69,0,356,1),(2197,70,0,356,0),(2198,71,0,356,0),(2199,151,0,356,0),(2206,46,0,358,1),(2207,54,0,358,1),(2208,69,0,358,1),(2209,70,0,358,0),(2210,71,0,358,0),(2211,151,0,358,0),(2212,46,0,359,1),(2213,54,0,359,1),(2214,69,0,359,1),(2215,70,0,359,0),(2216,71,0,359,0),(2217,151,0,359,0),(2218,46,0,360,1),(2219,54,0,360,1),(2220,69,0,360,1),(2221,70,0,360,0),(2222,71,0,360,0),(2223,151,0,360,0),(2224,46,0,361,1),(2225,54,0,361,1),(2226,69,0,361,1),(2227,70,0,361,0),(2228,71,0,361,0),(2229,151,0,361,0),(2230,46,0,362,1),(2231,54,0,362,1),(2232,69,0,362,1),(2233,70,0,362,0),(2234,71,0,362,0),(2235,151,0,362,0),(2236,46,0,363,1),(2237,54,0,363,1),(2238,69,0,363,1),(2239,70,0,363,0),(2240,71,0,363,0),(2241,151,0,363,0),(2242,46,0,364,1),(2243,54,0,364,1),(2244,69,0,364,1),(2245,70,0,364,0),(2246,71,0,364,0),(2247,151,0,364,0),(2248,46,0,365,1),(2249,54,0,365,1),(2250,69,0,365,1),(2251,70,0,365,0),(2252,71,0,365,0),(2253,151,0,365,0),(2254,46,0,366,1),(2255,54,0,366,1),(2256,69,0,366,1),(2257,70,0,366,0),(2258,71,0,366,0),(2259,151,0,366,0),(2260,46,0,367,1),(2261,54,0,367,1),(2262,69,0,367,1),(2263,70,0,367,0),(2264,71,0,367,0),(2265,151,0,367,0),(2266,46,0,368,1),(2267,54,0,368,1),(2268,69,0,368,1),(2269,70,0,368,0),(2270,71,0,368,0),(2271,151,0,368,0),(2272,46,0,369,1),(2273,54,0,369,1),(2274,69,0,369,1),(2275,70,0,369,0),(2276,71,0,369,0),(2277,151,0,369,0),(2278,46,0,370,1),(2279,54,0,370,1),(2280,69,0,370,1),(2281,70,0,370,0),(2282,71,0,370,0),(2283,151,0,370,0),(2284,53,0,370,NULL),(2285,151,0,141,0),(2286,151,0,140,0),(2287,151,0,138,0),(2288,151,0,142,0),(2289,46,0,371,1),(2290,54,0,371,1),(2291,69,0,371,1),(2292,70,0,371,0),(2293,71,0,371,0),(2294,151,0,371,0),(2295,46,0,372,1),(2296,54,0,372,1),(2297,69,0,372,1),(2298,70,0,372,0),(2299,71,0,372,0),(2300,151,0,372,0),(2301,46,0,373,1),(2302,54,0,373,1),(2303,69,0,373,1),(2304,70,0,373,0),(2305,71,0,373,0),(2306,151,0,373,0),(2307,46,0,374,1),(2308,54,0,374,1),(2309,69,0,374,1),(2310,70,0,374,0),(2311,71,0,374,0),(2312,151,0,374,0),(2313,46,0,375,1),(2314,54,0,375,1),(2315,69,0,375,1),(2316,70,0,375,0),(2317,71,0,375,0),(2318,151,0,375,0),(2319,46,0,376,1),(2320,54,0,376,1),(2321,69,0,376,1),(2322,70,0,376,0),(2323,71,0,376,0),(2324,151,0,376,0),(2325,46,0,377,1),(2326,54,0,377,1),(2327,69,0,377,1),(2328,70,0,377,0),(2329,71,0,377,0),(2330,151,0,377,0),(2331,151,0,6,0),(2332,46,0,378,1),(2333,54,0,378,1),(2334,69,0,378,1),(2335,70,0,378,0),(2336,71,0,378,0),(2337,151,0,378,0),(2338,46,0,379,1),(2339,54,0,379,1),(2340,69,0,379,1),(2341,70,0,379,0),(2342,71,0,379,0),(2343,151,0,379,0),(2344,151,0,119,0),(2345,151,0,114,0),(2346,46,0,380,1),(2347,54,0,380,1),(2348,69,0,380,1),(2349,70,0,380,0),(2350,71,0,380,0),(2351,151,0,380,0),(2352,151,0,112,0),(2353,151,0,116,0),(2354,151,0,122,0),(2355,151,0,133,0),(2356,46,0,381,1),(2357,54,0,381,1),(2358,69,0,381,1),(2359,70,0,381,0),(2360,71,0,381,0),(2361,151,0,381,0),(2362,46,0,382,1),(2363,54,0,382,1),(2364,69,0,382,1),(2365,70,0,382,0),(2366,71,0,382,0),(2367,151,0,382,0),(2368,151,0,127,0),(2369,46,0,383,1),(2370,54,0,383,1),(2371,69,0,383,1),(2372,70,0,383,0),(2373,71,0,383,0),(2374,151,0,383,0),(2375,46,0,384,1),(2376,54,0,384,1),(2377,69,0,384,1),(2378,70,0,384,0),(2379,71,0,384,0),(2380,151,0,384,0),(2381,151,0,134,0),(2382,46,0,385,1),(2383,54,0,385,1),(2384,69,0,385,1),(2385,70,0,385,0),(2386,71,0,385,0),(2387,151,0,385,0),(2388,46,0,386,1),(2389,54,0,386,1),(2390,69,0,386,1),(2391,70,0,386,0),(2392,71,0,386,0),(2393,151,0,386,0),(2394,46,0,387,1),(2395,54,0,387,1),(2396,69,0,387,1),(2397,70,0,387,0),(2398,71,0,387,0),(2399,151,0,387,0),(2400,46,0,388,1),(2401,54,0,388,1),(2402,69,0,388,1),(2403,70,0,388,0),(2404,71,0,388,0),(2405,151,0,388,0),(2406,46,0,389,1),(2407,54,0,389,1),(2408,69,0,389,1),(2409,70,0,389,0),(2410,71,0,389,0),(2411,151,0,389,0),(2412,46,0,390,1),(2413,54,0,390,1),(2414,69,0,390,1),(2415,70,0,390,0),(2416,71,0,390,0),(2417,151,0,390,0),(2418,46,0,391,1),(2419,54,0,391,1),(2420,69,0,391,1),(2421,70,0,391,0),(2422,71,0,391,0),(2423,151,0,391,0),(2424,46,0,392,1),(2425,54,0,392,1),(2426,69,0,392,1),(2427,70,0,392,0),(2428,71,0,392,0),(2429,151,0,392,0),(2430,46,0,393,1),(2431,54,0,393,1),(2432,69,0,393,1),(2433,70,0,393,0),(2434,71,0,393,0),(2435,151,0,393,0),(2436,46,0,394,1),(2437,54,0,394,1),(2438,69,0,394,1),(2439,70,0,394,0),(2440,71,0,394,0),(2441,151,0,394,0),(2442,46,0,395,1),(2443,54,0,395,1),(2444,69,0,395,1),(2445,70,0,395,0),(2446,71,0,395,0),(2447,151,0,395,0),(2448,46,0,396,1),(2449,54,0,396,1),(2450,69,0,396,1),(2451,70,0,396,0),(2452,71,0,396,0),(2453,151,0,396,0),(2454,46,0,397,1),(2455,54,0,397,1),(2456,69,0,397,1),(2457,70,0,397,0),(2458,71,0,397,0),(2459,151,0,397,0),(2460,46,0,398,1),(2461,54,0,398,1),(2462,69,0,398,1),(2463,70,0,398,0),(2464,71,0,398,0),(2465,151,0,398,0),(2466,46,0,399,1),(2467,54,0,399,1),(2468,69,0,399,1),(2469,70,0,399,0),(2470,71,0,399,0),(2471,151,0,399,0),(2472,46,0,400,1),(2473,54,0,400,1),(2474,69,0,400,1),(2475,70,0,400,0),(2476,71,0,400,0),(2477,151,0,400,0),(2478,46,0,401,1),(2479,54,0,401,1),(2480,69,0,401,1),(2481,70,0,401,0),(2482,71,0,401,0),(2483,151,0,401,0),(2484,46,0,402,1),(2485,54,0,402,1),(2486,69,0,402,1),(2487,70,0,402,0),(2488,71,0,402,0),(2489,151,0,402,0),(2490,46,0,403,1),(2491,54,0,403,1),(2492,69,0,403,1),(2493,70,0,403,0),(2494,71,0,403,0),(2495,151,0,403,0),(2496,46,0,404,1),(2497,54,0,404,1),(2498,69,0,404,1),(2499,70,0,404,0),(2500,71,0,404,0),(2501,151,0,404,0),(2502,46,0,405,1),(2503,54,0,405,1),(2504,69,0,405,1),(2505,70,0,405,0),(2506,71,0,405,0),(2507,151,0,405,0),(2508,46,0,406,1),(2509,54,0,406,1),(2510,69,0,406,1),(2511,70,0,406,0),(2512,71,0,406,0),(2513,151,0,406,0),(2514,46,0,407,1),(2515,54,0,407,1),(2516,69,0,407,1),(2517,70,0,407,0),(2518,71,0,407,0),(2519,151,0,407,0),(2520,46,0,408,1),(2521,54,0,408,1),(2522,69,0,408,1),(2523,70,0,408,0),(2524,71,0,408,0),(2525,151,0,408,0),(2526,46,0,409,1),(2527,54,0,409,1),(2528,69,0,409,1),(2529,70,0,409,0),(2530,71,0,409,0),(2531,151,0,409,0),(2532,46,0,410,1),(2533,54,0,410,1),(2534,69,0,410,1),(2535,70,0,410,0),(2536,71,0,410,0),(2537,151,0,410,0),(2538,46,0,411,1),(2539,54,0,411,1),(2540,69,0,411,1),(2541,70,0,411,0),(2542,71,0,411,0),(2543,151,0,411,0),(2544,46,0,412,1),(2545,54,0,412,1),(2546,69,0,412,1),(2547,70,0,412,0),(2548,71,0,412,0),(2549,151,0,412,0),(2550,46,0,413,1),(2551,54,0,413,1),(2552,69,0,413,1),(2553,70,0,413,0),(2554,71,0,413,0),(2555,151,0,413,0),(2556,46,0,414,1),(2557,54,0,414,1),(2558,69,0,414,1),(2559,70,0,414,0),(2560,71,0,414,0),(2561,151,0,414,0),(2562,46,0,415,1),(2563,54,0,415,1),(2564,69,0,415,1),(2565,70,0,415,0),(2566,71,0,415,0),(2567,151,0,415,0),(2568,46,0,416,1),(2569,54,0,416,1),(2570,69,0,416,1),(2571,70,0,416,0),(2572,71,0,416,0),(2573,151,0,416,0),(2574,46,0,417,1),(2575,54,0,417,1),(2576,69,0,417,1),(2577,70,0,417,0),(2578,71,0,417,0),(2579,151,0,417,0),(2580,46,0,418,1),(2581,54,0,418,1),(2582,69,0,418,1),(2583,70,0,418,0),(2584,71,0,418,0),(2585,151,0,418,0),(2586,46,0,419,1),(2587,54,0,419,1),(2588,69,0,419,1),(2589,70,0,419,0),(2590,71,0,419,0),(2591,151,0,419,0),(2592,46,0,420,1),(2593,54,0,420,1),(2594,69,0,420,1),(2595,70,0,420,0),(2596,71,0,420,0),(2597,151,0,420,0),(2598,46,0,421,1),(2599,54,0,421,1),(2600,69,0,421,1),(2601,70,0,421,0),(2602,71,0,421,0),(2603,151,0,421,0),(2604,46,0,422,1),(2605,54,0,422,1),(2606,69,0,422,1),(2607,70,0,422,0),(2608,71,0,422,0),(2609,151,0,422,0),(2610,46,0,423,1),(2611,54,0,423,1),(2612,69,0,423,1),(2613,70,0,423,0),(2614,71,0,423,0),(2615,151,0,423,0),(2616,46,0,424,1),(2617,54,0,424,1),(2618,69,0,424,1),(2619,70,0,424,0),(2620,71,0,424,0),(2621,151,0,424,0),(2622,46,0,425,1),(2623,54,0,425,1),(2624,69,0,425,1),(2625,70,0,425,0),(2626,71,0,425,0),(2627,151,0,425,0),(2628,46,0,426,1),(2629,54,0,426,1),(2630,69,0,426,1),(2631,70,0,426,0),(2632,71,0,426,0),(2633,151,0,426,0),(2634,46,0,427,1),(2635,54,0,427,1),(2636,69,0,427,1),(2637,70,0,427,0),(2638,71,0,427,0),(2639,151,0,427,0),(2640,46,0,428,1),(2641,54,0,428,1),(2642,69,0,428,1),(2643,70,0,428,0),(2644,71,0,428,0),(2645,151,0,428,0),(2646,46,0,429,1),(2647,54,0,429,1),(2648,69,0,429,1),(2649,70,0,429,0),(2650,71,0,429,0),(2651,151,0,429,0),(2652,46,0,430,1),(2653,54,0,430,1),(2654,69,0,430,1),(2655,70,0,430,0),(2656,71,0,430,0),(2657,151,0,430,0),(2658,46,0,431,1),(2659,54,0,431,1),(2660,69,0,431,1),(2661,70,0,431,0),(2662,71,0,431,0),(2663,151,0,431,0),(2664,46,0,432,1),(2665,54,0,432,1),(2666,69,0,432,1),(2667,70,0,432,0),(2668,71,0,432,0),(2669,151,0,432,0),(2670,46,0,433,1),(2671,54,0,433,1),(2672,69,0,433,1),(2673,70,0,433,0),(2674,71,0,433,0),(2675,151,0,433,0),(2676,46,0,434,1),(2677,54,0,434,1),(2678,69,0,434,1),(2679,70,0,434,0),(2680,71,0,434,0),(2681,151,0,434,0),(2682,46,0,435,1),(2683,54,0,435,1),(2684,69,0,435,1),(2685,70,0,435,0),(2686,71,0,435,0),(2687,151,0,435,0),(2688,46,0,436,1),(2689,54,0,436,1),(2690,69,0,436,1),(2691,70,0,436,0),(2692,71,0,436,0),(2693,151,0,436,0),(2694,46,0,437,1),(2695,54,0,437,1),(2696,69,0,437,1),(2697,70,0,437,0),(2698,71,0,437,0),(2699,151,0,437,0),(2700,46,0,438,1),(2701,54,0,438,1),(2702,69,0,438,1),(2703,70,0,438,0),(2704,71,0,438,0),(2705,151,0,438,0),(2706,46,0,439,1),(2707,54,0,439,1),(2708,69,0,439,1),(2709,70,0,439,0),(2710,71,0,439,0),(2711,151,0,439,0),(2712,46,0,440,1),(2713,54,0,440,1),(2714,69,0,440,1),(2715,70,0,440,0),(2716,71,0,440,0),(2717,151,0,440,0),(2718,46,0,441,1),(2719,54,0,441,1),(2720,69,0,441,1),(2721,70,0,441,0),(2722,71,0,441,0),(2723,151,0,441,0),(2724,46,0,442,1),(2725,54,0,442,1),(2726,69,0,442,1),(2727,70,0,442,0),(2728,71,0,442,0),(2729,151,0,442,0),(2730,46,0,443,1),(2731,54,0,443,1),(2732,69,0,443,1),(2733,70,0,443,0),(2734,71,0,443,0),(2735,151,0,443,0),(2736,151,0,10,0),(2737,151,0,11,0),(2738,53,0,203,NULL),(2739,53,0,405,NULL),(2740,46,0,444,1),(2741,54,0,444,1),(2742,69,0,444,1),(2743,70,0,444,0),(2744,71,0,444,0),(2745,151,0,444,0),(2746,53,0,444,NULL),(2747,53,0,406,NULL),(2748,53,0,407,NULL),(2749,53,0,408,NULL),(2750,53,0,409,NULL),(2751,53,0,410,NULL),(2752,53,0,411,NULL),(2753,53,0,413,NULL),(2754,53,0,414,NULL),(2755,53,0,415,NULL),(2756,53,0,416,NULL),(2757,53,0,417,NULL),(2758,53,0,418,NULL),(2759,53,0,419,NULL),(2760,53,0,420,NULL),(2761,53,0,422,NULL),(2762,53,0,424,NULL),(2763,53,0,425,NULL),(2764,53,0,426,NULL),(2765,53,0,427,NULL),(2766,53,0,429,NULL),(2767,53,0,430,NULL),(2768,53,0,431,NULL),(2769,53,0,432,NULL),(2770,53,0,433,NULL),(2771,53,0,434,NULL),(2772,53,0,435,NULL),(2773,53,0,436,NULL),(2774,53,0,437,NULL),(2775,53,0,439,NULL),(2776,53,0,441,NULL),(2777,53,0,442,NULL),(2778,53,0,443,NULL),(2779,53,0,440,NULL),(2780,53,0,368,NULL),(2781,151,0,143,0),(2782,53,0,371,NULL),(2783,53,0,373,NULL),(2784,53,0,374,NULL),(2785,53,0,375,NULL),(2786,53,0,376,NULL),(2787,53,0,377,NULL),(2788,53,0,366,NULL),(2789,53,0,307,NULL),(2790,151,0,121,0),(2791,151,0,123,0),(2792,151,0,118,0),(2793,53,0,379,NULL),(2794,151,0,113,0),(2795,151,0,132,0),(2796,53,0,381,NULL),(2797,53,0,382,NULL),(2798,151,0,124,0),(2799,151,0,128,0),(2800,151,0,125,0),(2801,53,0,383,NULL),(2802,151,0,126,0),(2803,53,0,385,NULL),(2804,53,0,386,NULL),(2805,53,0,387,NULL),(2806,46,0,445,1),(2807,54,0,445,1),(2808,69,0,445,1),(2809,70,0,445,0),(2810,71,0,445,0),(2811,151,0,445,0),(2812,53,0,445,NULL),(2813,53,0,308,NULL),(2814,53,0,309,NULL),(2815,53,0,310,NULL),(2816,53,0,311,NULL),(2817,53,0,312,NULL),(2818,53,0,313,NULL),(2819,151,0,108,0),(2820,53,0,314,NULL),(2821,53,0,315,NULL),(2822,53,0,322,NULL),(2823,53,0,324,NULL),(2824,53,0,325,NULL),(2825,53,0,326,NULL),(2826,53,0,328,NULL),(2827,53,0,327,NULL),(2828,151,0,145,0),(2829,53,0,329,NULL),(2830,53,0,330,NULL),(2831,53,0,331,NULL),(2832,53,0,336,NULL),(2833,53,0,345,NULL),(2834,53,0,346,NULL),(2835,53,0,338,NULL),(2836,53,0,339,NULL),(2837,53,0,340,NULL),(2838,53,0,341,NULL),(2839,53,0,342,NULL),(2840,53,0,359,NULL),(2841,53,0,360,NULL),(2842,53,0,361,NULL),(2843,53,0,362,NULL),(2844,151,0,88,0),(2845,151,0,89,0),(2846,151,0,90,0),(2847,151,0,91,0),(2848,151,0,93,0),(2849,151,0,94,0),(2850,151,0,95,0),(2851,151,0,100,0),(2852,151,0,102,0),(2853,151,0,103,0),(2854,151,0,101,0),(2855,151,0,104,0),(2856,151,0,105,0),(2857,151,0,97,0),(2858,151,0,98,0),(2859,151,0,99,0),(2860,53,0,351,NULL),(2861,53,0,352,NULL),(2862,53,0,353,NULL),(2863,53,0,354,NULL),(2864,53,0,355,NULL),(2865,151,0,17,0),(2866,151,0,16,0),(2867,53,0,198,NULL),(2868,151,0,18,0),(2869,53,0,200,NULL),(2870,151,0,24,0),(2871,53,0,205,NULL),(2872,53,0,365,NULL),(2873,53,0,349,NULL),(2874,53,0,210,NULL),(2875,53,0,211,NULL),(2876,53,0,212,NULL),(2877,53,0,213,NULL),(2878,53,0,214,NULL),(2879,53,0,215,NULL),(2880,53,0,216,NULL),(2881,151,0,15,0),(2882,53,0,221,NULL),(2883,53,0,222,NULL),(2884,151,0,27,0),(2885,151,0,33,0),(2886,151,0,32,0),(2887,151,0,30,0),(2888,53,0,208,NULL),(2889,151,0,60,0),(2890,53,0,227,NULL),(2891,151,0,190,0),(2892,53,0,229,NULL),(2893,53,0,231,NULL),(2894,53,0,232,NULL),(2895,53,0,233,NULL),(2896,53,0,234,NULL),(2897,53,0,235,NULL),(2898,53,0,236,NULL),(2899,53,0,237,NULL),(2900,53,0,238,NULL),(2901,151,0,176,0),(2902,151,0,167,0),(2903,151,0,172,0),(2904,53,0,239,NULL),(2905,151,0,177,0),(2906,151,0,180,0),(2907,151,0,178,0),(2908,53,0,241,NULL),(2909,53,0,242,NULL),(2910,53,0,243,NULL),(2911,53,0,244,NULL),(2912,46,0,446,1),(2913,54,0,446,1),(2914,69,0,446,1),(2915,70,0,446,0),(2916,71,0,446,0),(2917,151,0,446,0),(2918,46,0,447,1),(2919,54,0,447,1),(2920,69,0,447,1),(2921,70,0,447,0),(2922,71,0,447,0),(2923,151,0,447,0),(2930,46,0,449,1),(2931,54,0,449,1),(2932,69,0,449,1),(2933,70,0,449,0),(2934,71,0,449,0),(2935,151,0,449,0),(2936,53,0,449,NULL),(2937,151,0,2,0),(2938,163,0,2,0),(2939,163,0,449,0),(2947,163,0,219,0),(2948,163,0,25,0),(2949,163,0,5,1),(2950,163,0,3,1),(2951,163,0,15,1),(2952,151,0,7,0),(2953,163,0,7,1),(2954,151,0,12,0),(2955,163,0,12,1),(2956,151,0,8,0),(2957,163,0,8,1),(2958,151,0,9,0),(2959,163,0,9,0),(2960,163,3,15,0),(2961,163,4,8,0),(2963,163,1,165,1),(2964,163,1,15,0),(2965,163,1,8,0),(2966,163,3,8,0),(2967,163,3,12,0),(2970,163,3,135,1),(2972,163,3,367,1),(2973,46,3,318,1),(2974,69,3,318,1),(2975,163,3,318,1),(2976,163,3,145,1),(2977,163,0,318,0),(2978,163,0,346,0),(2979,163,0,106,0),(2980,163,0,307,0),(2981,163,2,5,0),(2982,46,2,5,0),(2983,69,2,5,1),(2984,151,2,5,0),(2985,163,1,5,1),(2986,163,3,5,0),(2987,163,4,7,0),(2988,163,5,5,0),(2989,46,5,318,1),(2990,69,5,318,1),(2991,163,5,318,0),(2992,46,5,5,1),(2993,69,5,5,1),(2994,46,5,7,1),(2995,69,5,7,1),(2996,163,5,7,0),(2997,46,5,366,1),(2998,69,5,366,1),(2999,163,5,366,1),(3000,46,5,219,1),(3001,69,5,219,1),(3002,163,5,219,1),(3003,46,1,318,1),(3004,69,1,318,1),(3005,163,1,318,0),(3006,163,1,163,0),(3007,46,3,3,1),(3008,69,3,3,1),(3009,163,3,3,0),(3010,46,3,219,1),(3011,69,3,219,1),(3012,163,3,219,1),(3015,163,3,4,1),(3016,46,3,71,1),(3017,69,3,71,1),(3018,163,3,71,0),(3019,163,3,37,1),(3020,46,3,25,1),(3021,69,3,25,1),(3022,163,3,25,1),(3023,46,3,9,1),(3024,69,3,9,1),(3025,163,3,9,1),(3026,46,3,5,1),(3027,69,3,5,1),(3028,46,3,145,1),(3029,69,3,145,1),(3030,46,3,253,1),(3031,69,3,253,1),(3032,163,3,253,1),(3033,151,0,71,0),(3034,163,0,71,0),(3035,163,1,4,1),(3037,46,3,4,1),(3038,163,3,343,1),(3039,163,1,343,1),(3040,69,3,4,1),(3041,151,3,4,0);
/*!40000 ALTER TABLE `catalog_category_entity_int` ENABLE KEYS */;
UNLOCK TABLES;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalog_category_entity_int_after_insert` AFTER INSERT ON `catalog_category_entity_int` FOR EACH ROW BEGIN
INSERT IGNORE INTO `catalog_category_product_cl` (`entity_id`) VALUES (NEW.`entity_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalog_category_entity_int_after_update` AFTER UPDATE ON `catalog_category_entity_int` FOR EACH ROW BEGIN
IF (NOT(NEW.`value_id` <=> OLD.`value_id`) OR NOT(NEW.`attribute_id` <=> OLD.`attribute_id`) OR NOT(NEW.`store_id` <=> OLD.`store_id`) OR NOT(NEW.`entity_id` <=> OLD.`entity_id`) OR NOT(NEW.`value` <=> OLD.`value`)) THEN INSERT IGNORE INTO `catalog_category_product_cl` (`entity_id`) VALUES (NEW.`entity_id`); END IF;
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalog_category_entity_int_after_delete` AFTER DELETE ON `catalog_category_entity_int` FOR EACH ROW BEGIN
INSERT IGNORE INTO `catalog_category_product_cl` (`entity_id`) VALUES (OLD.`entity_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2025-02-05  7:56:26
