-- MySQL dump 10.13  Distrib 8.0.41, for Linux (x86_64)
--
-- Host: localhost    Database: magentodb
-- ------------------------------------------------------
-- Server version	8.0.41-0ubuntu0.24.04.1

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!50503 SET NAMES utf8mb4 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `eav_attribute`
--

DROP TABLE IF EXISTS `eav_attribute`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `eav_attribute` (
  `attribute_id` smallint unsigned NOT NULL AUTO_INCREMENT COMMENT 'Attribute ID',
  `entity_type_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Type ID',
  `attribute_code` varchar(255) NOT NULL COMMENT 'Attribute Code',
  `attribute_model` varchar(255) DEFAULT NULL COMMENT 'Attribute Model',
  `backend_model` varchar(255) DEFAULT NULL COMMENT 'Backend Model',
  `backend_type` varchar(8) NOT NULL DEFAULT 'static' COMMENT 'Backend Type',
  `backend_table` varchar(255) DEFAULT NULL COMMENT 'Backend Table',
  `frontend_model` varchar(255) DEFAULT NULL COMMENT 'Frontend Model',
  `frontend_input` varchar(50) DEFAULT NULL COMMENT 'Frontend Input',
  `frontend_label` varchar(255) DEFAULT NULL COMMENT 'Frontend Label',
  `frontend_class` varchar(255) DEFAULT NULL COMMENT 'Frontend Class',
  `source_model` varchar(255) DEFAULT NULL COMMENT 'Source Model',
  `is_required` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Defines Is Required',
  `is_user_defined` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Defines Is User Defined',
  `default_value` text COMMENT 'Default Value',
  `is_unique` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Defines Is Unique',
  `note` varchar(255) DEFAULT NULL COMMENT 'Note',
  PRIMARY KEY (`attribute_id`),
  UNIQUE KEY `EAV_ATTRIBUTE_ENTITY_TYPE_ID_ATTRIBUTE_CODE` (`entity_type_id`,`attribute_code`),
  KEY `EAV_ATTRIBUTE_FRONTEND_INPUT_ENTITY_TYPE_ID_IS_USER_DEFINED` (`frontend_input`,`entity_type_id`,`is_user_defined`),
  CONSTRAINT `EAV_ATTRIBUTE_ENTITY_TYPE_ID_EAV_ENTITY_TYPE_ENTITY_TYPE_ID` FOREIGN KEY (`entity_type_id`) REFERENCES `eav_entity_type` (`entity_type_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=208 DEFAULT CHARSET=utf8mb3 COMMENT='Eav Attribute';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `eav_attribute`
--

LOCK TABLES `eav_attribute` WRITE;
/*!40000 ALTER TABLE `eav_attribute` DISABLE KEYS */;
INSERT INTO `eav_attribute` VALUES (1,1,'website_id',NULL,'Magento\\Customer\\Model\\Customer\\Attribute\\Backend\\Website','static',NULL,NULL,'select','Associate to Website',NULL,'Magento\\Customer\\Model\\Customer\\Attribute\\Source\\Website',1,0,NULL,0,NULL),(2,1,'store_id',NULL,'Magento\\Customer\\Model\\Customer\\Attribute\\Backend\\Store','static',NULL,NULL,'select','Create In',NULL,'Magento\\Customer\\Model\\Customer\\Attribute\\Source\\Store',1,0,NULL,0,NULL),(3,1,'created_in',NULL,NULL,'static',NULL,NULL,'text','Created From',NULL,NULL,0,0,NULL,0,NULL),(4,1,'prefix',NULL,NULL,'static',NULL,NULL,'text','Name Prefix',NULL,NULL,0,0,NULL,0,NULL),(5,1,'firstname',NULL,NULL,'static',NULL,NULL,'text','First Name',NULL,NULL,1,0,NULL,0,NULL),(6,1,'middlename',NULL,NULL,'static',NULL,NULL,'text','Middle Name/Initial',NULL,NULL,0,0,NULL,0,NULL),(7,1,'lastname',NULL,NULL,'static',NULL,NULL,'text','Last Name',NULL,NULL,1,0,NULL,0,NULL),(8,1,'suffix',NULL,NULL,'static',NULL,NULL,'text','Name Suffix',NULL,NULL,0,0,NULL,0,NULL),(9,1,'email',NULL,NULL,'static',NULL,NULL,'text','Email',NULL,NULL,1,0,NULL,0,NULL),(10,1,'group_id',NULL,NULL,'static',NULL,NULL,'select','Group',NULL,'Magento\\Customer\\Model\\Customer\\Attribute\\Source\\Group',1,0,NULL,0,NULL),(11,1,'dob',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\Datetime','static',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Frontend\\Datetime','date','Date of Birth',NULL,NULL,0,0,NULL,0,NULL),(12,1,'password_hash',NULL,'Magento\\Customer\\Model\\Customer\\Attribute\\Backend\\Password','static',NULL,NULL,'hidden',NULL,NULL,NULL,0,0,NULL,0,NULL),(13,1,'rp_token',NULL,NULL,'static',NULL,NULL,'hidden',NULL,NULL,NULL,0,0,NULL,0,NULL),(14,1,'rp_token_created_at',NULL,NULL,'static',NULL,NULL,'date',NULL,NULL,NULL,0,0,NULL,0,NULL),(15,1,'default_billing',NULL,'Magento\\Customer\\Model\\Customer\\Attribute\\Backend\\Billing','static',NULL,NULL,'text','Default Billing Address',NULL,NULL,0,0,NULL,0,NULL),(16,1,'default_shipping',NULL,'Magento\\Customer\\Model\\Customer\\Attribute\\Backend\\Shipping','static',NULL,NULL,'text','Default Shipping Address',NULL,NULL,0,0,NULL,0,NULL),(17,1,'taxvat',NULL,NULL,'static',NULL,NULL,'text','Tax/VAT Number',NULL,NULL,0,0,NULL,0,NULL),(18,1,'confirmation',NULL,NULL,'static',NULL,NULL,'text','Is Confirmed',NULL,NULL,0,0,NULL,0,NULL),(19,1,'created_at',NULL,NULL,'static',NULL,NULL,'date','Created At',NULL,NULL,0,0,NULL,0,NULL),(20,1,'gender',NULL,NULL,'static',NULL,NULL,'select','Gender',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Table',0,0,NULL,0,NULL),(21,1,'disable_auto_group_change','Magento\\Customer\\Model\\Attribute','Magento\\Customer\\Model\\Attribute\\Backend\\Data\\Boolean','static',NULL,NULL,'boolean','Disable Automatic Group Change Based on VAT ID',NULL,NULL,0,0,NULL,0,NULL),(22,2,'prefix',NULL,NULL,'static',NULL,NULL,'text','Name Prefix',NULL,NULL,0,0,NULL,0,NULL),(23,2,'firstname',NULL,NULL,'static',NULL,NULL,'text','First Name',NULL,NULL,1,0,NULL,0,NULL),(24,2,'middlename',NULL,NULL,'static',NULL,NULL,'text','Middle Name/Initial',NULL,NULL,0,0,NULL,0,NULL),(25,2,'lastname',NULL,NULL,'static',NULL,NULL,'text','Last Name',NULL,NULL,1,0,NULL,0,NULL),(26,2,'suffix',NULL,NULL,'static',NULL,NULL,'text','Name Suffix',NULL,NULL,0,0,NULL,0,NULL),(27,2,'company',NULL,NULL,'static',NULL,NULL,'text','Company',NULL,NULL,0,0,NULL,0,NULL),(28,2,'street',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\DefaultBackend','static',NULL,NULL,'multiline','Street Address',NULL,NULL,1,0,NULL,0,NULL),(29,2,'city',NULL,NULL,'static',NULL,NULL,'text','City',NULL,NULL,1,0,NULL,0,NULL),(30,2,'country_id',NULL,NULL,'static',NULL,NULL,'select','Country',NULL,'Magento\\Customer\\Model\\ResourceModel\\Address\\Attribute\\Source\\Country',1,0,NULL,0,NULL),(31,2,'region',NULL,'Magento\\Customer\\Model\\ResourceModel\\Address\\Attribute\\Backend\\Region','static',NULL,NULL,'text','State/Province',NULL,NULL,0,0,NULL,0,NULL),(32,2,'region_id',NULL,NULL,'static',NULL,NULL,'hidden','State/Province',NULL,'Magento\\Customer\\Model\\ResourceModel\\Address\\Attribute\\Source\\Region',0,0,NULL,0,NULL),(33,2,'postcode',NULL,NULL,'static',NULL,NULL,'text','Zip/Postal Code',NULL,NULL,0,0,NULL,0,NULL),(34,2,'telephone',NULL,NULL,'static',NULL,NULL,'text','Phone Number',NULL,NULL,1,0,NULL,0,NULL),(35,2,'fax',NULL,NULL,'static',NULL,NULL,'text','Fax',NULL,NULL,0,0,NULL,0,NULL),(36,2,'vat_id','Magento\\Customer\\Model\\Attribute',NULL,'static',NULL,NULL,'text','VAT Number',NULL,NULL,0,0,NULL,0,NULL),(37,2,'vat_is_valid',NULL,NULL,'static',NULL,NULL,'text','VAT number validity',NULL,NULL,0,0,NULL,0,NULL),(38,2,'vat_request_id',NULL,NULL,'static',NULL,NULL,'text','VAT number validation request ID',NULL,NULL,0,0,NULL,0,NULL),(39,2,'vat_request_date',NULL,NULL,'static',NULL,NULL,'text','VAT number validation request date',NULL,NULL,0,0,NULL,0,NULL),(40,2,'vat_request_success',NULL,NULL,'static',NULL,NULL,'text','VAT number validation request success',NULL,NULL,0,0,NULL,0,NULL),(41,1,'updated_at',NULL,NULL,'static',NULL,NULL,'date','Updated At',NULL,NULL,0,0,NULL,0,NULL),(42,1,'failures_num',NULL,NULL,'static',NULL,NULL,'hidden','Failures Number',NULL,NULL,0,0,NULL,0,NULL),(43,1,'first_failure',NULL,NULL,'static',NULL,NULL,'date','First Failure Date',NULL,NULL,0,0,NULL,0,NULL),(44,1,'lock_expires',NULL,NULL,'static',NULL,NULL,'date','Failures Number',NULL,NULL,0,0,NULL,0,NULL),(45,3,'name',NULL,NULL,'varchar',NULL,NULL,'text','Name',NULL,NULL,1,0,NULL,0,NULL),(46,3,'is_active',NULL,NULL,'int',NULL,NULL,'select','Is Active',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Boolean',1,0,NULL,0,NULL),(47,3,'description',NULL,NULL,'text',NULL,NULL,'textarea','Description',NULL,NULL,0,0,NULL,0,NULL),(48,3,'image',NULL,'Magento\\Catalog\\Model\\Category\\Attribute\\Backend\\Image','varchar',NULL,NULL,'image','Image',NULL,NULL,0,0,NULL,0,NULL),(49,3,'meta_title',NULL,NULL,'varchar',NULL,NULL,'text','Page Title',NULL,NULL,0,0,NULL,0,NULL),(50,3,'meta_keywords',NULL,NULL,'text',NULL,NULL,'textarea','Meta Keywords',NULL,NULL,0,0,NULL,0,NULL),(51,3,'meta_description',NULL,NULL,'text',NULL,NULL,'textarea','Meta Description',NULL,NULL,0,0,NULL,0,NULL),(52,3,'display_mode',NULL,NULL,'varchar',NULL,NULL,'select','Display Mode',NULL,'Magento\\Catalog\\Model\\Category\\Attribute\\Source\\Mode',0,0,NULL,0,NULL),(53,3,'landing_page',NULL,NULL,'int',NULL,NULL,'select','CMS Block',NULL,'Magento\\Catalog\\Model\\Category\\Attribute\\Source\\Page',0,0,NULL,0,NULL),(54,3,'is_anchor',NULL,NULL,'int',NULL,NULL,'select','Is Anchor',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Boolean',0,0,'1',0,NULL),(55,3,'path',NULL,NULL,'static',NULL,NULL,'text','Path',NULL,NULL,0,0,NULL,0,NULL),(56,3,'position',NULL,NULL,'static',NULL,NULL,'text','Position',NULL,NULL,0,0,NULL,0,NULL),(57,3,'all_children',NULL,NULL,'text',NULL,NULL,'text',NULL,NULL,NULL,0,0,NULL,0,NULL),(58,3,'path_in_store',NULL,NULL,'text',NULL,NULL,'text',NULL,NULL,NULL,0,0,NULL,0,NULL),(59,3,'children',NULL,NULL,'text',NULL,NULL,'text',NULL,NULL,NULL,0,0,NULL,0,NULL),(60,3,'custom_design',NULL,NULL,'varchar',NULL,NULL,'select','Custom Design',NULL,'Magento\\Theme\\Model\\Theme\\Source\\Theme',0,0,NULL,0,NULL),(61,3,'custom_design_from','Magento\\Catalog\\Model\\ResourceModel\\Eav\\Attribute','Magento\\Catalog\\Model\\Attribute\\Backend\\Startdate','datetime',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Frontend\\Datetime','date','Active From',NULL,NULL,0,0,NULL,0,NULL),(62,3,'custom_design_to',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\Datetime','datetime',NULL,NULL,'date','Active To',NULL,NULL,0,0,NULL,0,NULL),(63,3,'page_layout',NULL,NULL,'varchar',NULL,NULL,'select','Page Layout',NULL,'Magento\\Catalog\\Model\\Category\\Attribute\\Source\\Layout',0,0,NULL,0,NULL),(64,3,'custom_layout_update',NULL,'Magento\\Catalog\\Model\\Attribute\\Backend\\Customlayoutupdate','text',NULL,NULL,'textarea','Custom Layout Update',NULL,NULL,0,0,NULL,0,NULL),(65,3,'level',NULL,NULL,'static',NULL,NULL,'text','Level',NULL,NULL,0,0,NULL,0,NULL),(66,3,'children_count',NULL,NULL,'static',NULL,NULL,'text','Children Count',NULL,NULL,0,0,NULL,0,NULL),(67,3,'available_sort_by',NULL,'Magento\\Catalog\\Model\\Category\\Attribute\\Backend\\Sortby','text',NULL,NULL,'multiselect','Available Product Listing Sort By',NULL,'Magento\\Catalog\\Model\\Category\\Attribute\\Source\\Sortby',1,0,NULL,0,NULL),(68,3,'default_sort_by',NULL,'Magento\\Catalog\\Model\\Category\\Attribute\\Backend\\Sortby','varchar',NULL,NULL,'select','Default Product Listing Sort By',NULL,'Magento\\Catalog\\Model\\Category\\Attribute\\Source\\Sortby',1,0,NULL,0,NULL),(69,3,'include_in_menu',NULL,NULL,'int',NULL,NULL,'select','Include in Navigation Menu',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Boolean',1,0,'1',0,NULL),(70,3,'custom_use_parent_settings',NULL,NULL,'int',NULL,NULL,'select','Use Parent Category Settings',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Boolean',0,0,NULL,0,NULL),(71,3,'custom_apply_to_products',NULL,NULL,'int',NULL,NULL,'select','Apply To Products',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Boolean',0,0,NULL,0,NULL),(72,3,'filter_price_range',NULL,NULL,'decimal',NULL,NULL,'text','Layered Navigation Price Step',NULL,NULL,0,0,NULL,0,NULL),(73,4,'name','Magento\\Catalog\\Model\\ResourceModel\\Eav\\Attribute',NULL,'varchar',NULL,NULL,'text','Product Name','validate-length maximum-length-255',NULL,1,0,NULL,0,NULL),(74,4,'sku','Magento\\Catalog\\Model\\ResourceModel\\Eav\\Attribute','Magento\\Catalog\\Model\\Product\\Attribute\\Backend\\Sku','static',NULL,NULL,'text','SKU','validate-length maximum-length-64',NULL,1,0,NULL,1,NULL),(75,4,'description',NULL,NULL,'text',NULL,NULL,'textarea','Description',NULL,NULL,0,0,NULL,0,NULL),(76,4,'short_description',NULL,NULL,'text',NULL,NULL,'textarea','Short Description',NULL,NULL,0,0,NULL,0,NULL),(77,4,'price',NULL,'Magento\\Catalog\\Model\\Product\\Attribute\\Backend\\Price','decimal',NULL,NULL,'price','Price',NULL,NULL,1,0,NULL,0,NULL),(78,4,'special_price','Magento\\Catalog\\Model\\ResourceModel\\Eav\\Attribute','Magento\\Catalog\\Model\\Product\\Attribute\\Backend\\Price','decimal',NULL,NULL,'price','Special Price',NULL,NULL,0,0,NULL,0,NULL),(79,4,'special_from_date',NULL,'Magento\\Catalog\\Model\\Attribute\\Backend\\Startdate','datetime',NULL,NULL,'date','Special Price From Date',NULL,NULL,0,0,NULL,0,NULL),(80,4,'special_to_date',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\Datetime','datetime',NULL,NULL,'date','Special Price To Date',NULL,NULL,0,0,NULL,0,NULL),(81,4,'cost',NULL,'Magento\\Catalog\\Model\\Product\\Attribute\\Backend\\Price','decimal',NULL,NULL,'price','Cost',NULL,NULL,0,1,NULL,0,NULL),(82,4,'weight',NULL,'Magento\\Catalog\\Model\\Product\\Attribute\\Backend\\Weight','decimal',NULL,NULL,'weight','Weight',NULL,NULL,0,0,NULL,0,NULL),(83,4,'manufacturer',NULL,NULL,'int',NULL,NULL,'select','Manufacturer',NULL,NULL,0,1,NULL,0,NULL),(84,4,'meta_title',NULL,NULL,'varchar',NULL,NULL,'text','Meta Title',NULL,NULL,0,0,NULL,0,NULL),(85,4,'meta_keyword',NULL,NULL,'text',NULL,NULL,'textarea','Meta Keywords',NULL,NULL,0,0,NULL,0,NULL),(86,4,'meta_description',NULL,NULL,'varchar',NULL,NULL,'textarea','Meta Description',NULL,NULL,0,0,NULL,0,'Maximum 255 chars. Meta Description should optimally be between 150-160 characters'),(87,4,'image',NULL,NULL,'varchar',NULL,'Magento\\Catalog\\Model\\Product\\Attribute\\Frontend\\Image','media_image','Base',NULL,NULL,0,0,NULL,0,NULL),(88,4,'small_image',NULL,NULL,'varchar',NULL,'Magento\\Catalog\\Model\\Product\\Attribute\\Frontend\\Image','media_image','Small',NULL,NULL,0,0,NULL,0,NULL),(89,4,'thumbnail',NULL,NULL,'varchar',NULL,'Magento\\Catalog\\Model\\Product\\Attribute\\Frontend\\Image','media_image','Thumbnail',NULL,NULL,0,0,NULL,0,NULL),(90,4,'media_gallery',NULL,NULL,'static',NULL,NULL,'gallery','Media Gallery',NULL,NULL,0,0,NULL,0,NULL),(91,4,'old_id',NULL,NULL,'int',NULL,NULL,'text',NULL,NULL,NULL,0,0,NULL,0,NULL),(92,4,'tier_price',NULL,'Magento\\Catalog\\Model\\Product\\Attribute\\Backend\\Tierprice','decimal',NULL,NULL,'text','Tier Price',NULL,NULL,0,0,NULL,0,NULL),(93,4,'color',NULL,NULL,'int',NULL,NULL,'select','Color',NULL,NULL,0,1,'',0,NULL),(94,4,'news_from_date',NULL,'Magento\\Catalog\\Model\\Attribute\\Backend\\Startdate','datetime',NULL,NULL,'date','Set Product as New from Date',NULL,NULL,0,0,NULL,0,NULL),(95,4,'news_to_date',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\Datetime','datetime',NULL,NULL,'date','Set Product as New to Date',NULL,NULL,0,0,NULL,0,NULL),(96,4,'gallery',NULL,NULL,'varchar',NULL,NULL,'gallery','Image Gallery',NULL,NULL,0,0,NULL,0,NULL),(97,4,'status',NULL,NULL,'int',NULL,NULL,'select','Enable Product',NULL,'Magento\\Catalog\\Model\\Product\\Attribute\\Source\\Status',0,0,'1',0,NULL),(98,4,'minimal_price','Magento\\Catalog\\Model\\ResourceModel\\Eav\\Attribute','Magento\\Catalog\\Model\\Product\\Attribute\\Backend\\Price','decimal',NULL,NULL,'price','Minimal Price',NULL,NULL,0,0,NULL,0,NULL),(99,4,'visibility',NULL,NULL,'int',NULL,NULL,'select','Visibility',NULL,'Magento\\Catalog\\Model\\Product\\Visibility',0,0,'4',0,NULL),(100,4,'custom_design',NULL,NULL,'varchar',NULL,NULL,'select','New Theme',NULL,'Magento\\Theme\\Model\\Theme\\Source\\Theme',0,0,NULL,0,NULL),(101,4,'custom_design_from',NULL,'Magento\\Catalog\\Model\\Attribute\\Backend\\Startdate','datetime',NULL,NULL,'date','Active From',NULL,NULL,0,0,NULL,0,NULL),(102,4,'custom_design_to',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\Datetime','datetime',NULL,NULL,'date','Active To',NULL,NULL,0,0,NULL,0,NULL),(103,4,'custom_layout_update',NULL,'Magento\\Catalog\\Model\\Attribute\\Backend\\Customlayoutupdate','text',NULL,NULL,'textarea','Layout Update XML',NULL,NULL,0,0,NULL,0,NULL),(104,4,'page_layout',NULL,NULL,'varchar',NULL,NULL,'select','Layout',NULL,'Magento\\Catalog\\Model\\Product\\Attribute\\Source\\Layout',0,0,NULL,0,NULL),(105,4,'category_ids',NULL,'Magento\\Catalog\\Model\\Product\\Attribute\\Backend\\Category','static',NULL,NULL,'text','Categories',NULL,NULL,0,0,NULL,0,NULL),(106,4,'options_container',NULL,NULL,'varchar',NULL,NULL,'select','Display Product Options In',NULL,'Magento\\Catalog\\Model\\Entity\\Product\\Attribute\\Design\\Options\\Container',0,0,'container2',0,NULL),(107,4,'required_options',NULL,NULL,'static',NULL,NULL,'text',NULL,NULL,NULL,0,0,NULL,0,NULL),(108,4,'has_options',NULL,NULL,'static',NULL,NULL,'text',NULL,NULL,NULL,0,0,NULL,0,NULL),(109,4,'image_label',NULL,NULL,'varchar',NULL,NULL,'text','Image Label',NULL,NULL,0,0,NULL,0,NULL),(110,4,'small_image_label',NULL,NULL,'varchar',NULL,NULL,'text','Small Image Label',NULL,NULL,0,0,NULL,0,NULL),(111,4,'thumbnail_label',NULL,NULL,'varchar',NULL,NULL,'text','Thumbnail Label',NULL,NULL,0,0,NULL,0,NULL),(112,4,'created_at',NULL,NULL,'static',NULL,NULL,'date',NULL,NULL,NULL,1,0,NULL,0,NULL),(113,4,'updated_at',NULL,NULL,'static',NULL,NULL,'date',NULL,NULL,NULL,1,0,NULL,0,NULL),(114,4,'country_of_manufacture',NULL,NULL,'varchar',NULL,NULL,'select','Country of Manufacture',NULL,'Magento\\Catalog\\Model\\Product\\Attribute\\Source\\Countryofmanufacture',0,0,NULL,0,NULL),(115,4,'quantity_and_stock_status',NULL,'Magento\\Catalog\\Model\\Product\\Attribute\\Backend\\Stock','int',NULL,NULL,'select','Quantity',NULL,'Magento\\CatalogInventory\\Model\\Source\\Stock',0,0,'1',0,NULL),(116,4,'custom_layout',NULL,NULL,'varchar',NULL,NULL,'select','New Layout',NULL,'Magento\\Catalog\\Model\\Product\\Attribute\\Source\\Layout',0,0,NULL,0,NULL),(117,4,'custom_layout_update_file',NULL,'Magento\\Catalog\\Model\\Product\\Attribute\\Backend\\LayoutUpdate','varchar',NULL,NULL,'select','Custom Layout Update',NULL,'Magento\\Catalog\\Model\\Product\\Attribute\\Source\\LayoutUpdate',0,0,NULL,0,NULL),(118,3,'custom_layout_update_file',NULL,'Magento\\Catalog\\Model\\Category\\Attribute\\Backend\\LayoutUpdate','varchar',NULL,NULL,'select','Custom Layout Update',NULL,'Magento\\Catalog\\Model\\Category\\Attribute\\Source\\LayoutUpdate',0,0,NULL,0,NULL),(119,3,'url_key',NULL,NULL,'varchar',NULL,NULL,'text','URL Key',NULL,NULL,0,0,NULL,0,NULL),(120,3,'url_path',NULL,NULL,'varchar',NULL,NULL,'text',NULL,NULL,NULL,0,0,NULL,0,NULL),(121,4,'url_key',NULL,NULL,'varchar',NULL,NULL,'text','URL Key','validate-trailing-hyphen',NULL,0,0,NULL,0,NULL),(122,4,'url_path',NULL,NULL,'varchar',NULL,NULL,'text',NULL,NULL,NULL,0,0,NULL,0,NULL),(123,4,'msrp','Magento\\Catalog\\Model\\ResourceModel\\Eav\\Attribute','Magento\\Catalog\\Model\\Product\\Attribute\\Backend\\Price','decimal',NULL,NULL,'price','Minimum Advertised Price',NULL,NULL,0,0,NULL,0,NULL),(124,4,'msrp_display_actual_price_type',NULL,'Magento\\Catalog\\Model\\Product\\Attribute\\Backend\\Boolean','varchar',NULL,NULL,'select','Display Actual Price',NULL,'Magento\\Msrp\\Model\\Product\\Attribute\\Source\\Type\\Price',0,0,'0',0,NULL),(125,4,'links_purchased_separately',NULL,NULL,'int',NULL,NULL,NULL,'Links can be purchased separately',NULL,NULL,1,0,NULL,0,NULL),(126,4,'samples_title',NULL,NULL,'varchar',NULL,NULL,NULL,'Samples title',NULL,NULL,1,0,NULL,0,NULL),(127,4,'links_title',NULL,NULL,'varchar',NULL,NULL,NULL,'Links title',NULL,NULL,1,0,NULL,0,NULL),(128,4,'links_exist',NULL,NULL,'int',NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,0,NULL),(129,4,'price_type',NULL,NULL,'int',NULL,NULL,'boolean','Dynamic Price',NULL,NULL,1,0,'0',0,NULL),(130,4,'sku_type',NULL,NULL,'int',NULL,NULL,'boolean','Dynamic SKU',NULL,NULL,1,0,'0',0,NULL),(131,4,'weight_type',NULL,NULL,'int',NULL,NULL,'boolean','Dynamic Weight',NULL,NULL,1,0,'0',0,NULL),(132,4,'price_view',NULL,NULL,'int',NULL,NULL,'select','Price View',NULL,'Magento\\Bundle\\Model\\Product\\Attribute\\Source\\Price\\View',1,0,NULL,0,NULL),(133,4,'shipment_type',NULL,NULL,'int',NULL,NULL,'select','Ship Bundle Items',NULL,'Magento\\Bundle\\Model\\Product\\Attribute\\Source\\Shipment\\Type',1,0,'0',0,NULL),(134,4,'gift_message_available',NULL,'Magento\\Catalog\\Model\\Product\\Attribute\\Backend\\Boolean','varchar',NULL,NULL,'select','Allow Gift Message',NULL,'Magento\\Catalog\\Model\\Product\\Attribute\\Source\\Boolean',0,0,NULL,0,NULL),(135,4,'swatch_image',NULL,NULL,'varchar',NULL,'Magento\\Catalog\\Model\\Product\\Attribute\\Frontend\\Image','media_image','Swatch',NULL,NULL,0,0,NULL,0,NULL),(136,4,'tax_class_id',NULL,NULL,'int',NULL,NULL,'select','Tax Class',NULL,'Magento\\Tax\\Model\\TaxClass\\Source\\Product',0,0,'2',0,NULL),(137,3,'first_tab',NULL,NULL,'text',NULL,NULL,'textarea','First Tab',NULL,NULL,0,1,NULL,0,NULL),(138,3,'second_tab',NULL,NULL,'text',NULL,NULL,'textarea','Second Tab',NULL,NULL,0,1,NULL,0,NULL),(139,3,'third_tab',NULL,NULL,'text',NULL,NULL,'textarea','Third Tab',NULL,NULL,0,1,NULL,0,NULL),(140,4,'kitchen_sinks',NULL,NULL,'int',NULL,NULL,'boolean','Kitchen Sinks',NULL,NULL,0,1,'0',0,NULL),(141,4,'bestsellers',NULL,NULL,'int',NULL,NULL,'boolean','Bestsellers',NULL,NULL,0,1,'0',0,NULL),(142,4,'bath_enclosures',NULL,NULL,'int',NULL,NULL,'boolean','Bath Enclosures',NULL,NULL,0,1,'0',0,NULL),(143,4,'whirlpool_baths',NULL,NULL,'int',NULL,NULL,'boolean','Whirlpool Baths',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Boolean',0,1,'0',0,NULL),(144,4,'shower_baths',NULL,NULL,'int',NULL,NULL,'boolean','Shower Baths',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Boolean',0,1,'0',0,NULL),(145,4,'product_faq',NULL,NULL,'text',NULL,NULL,'textarea','Question And Answer',NULL,NULL,0,1,NULL,0,NULL),(146,4,'product_dimensions',NULL,NULL,'text',NULL,NULL,'textarea','Product Dimensions',NULL,NULL,0,1,NULL,0,NULL),(147,4,'top_rated',NULL,NULL,'int',NULL,NULL,'boolean','Top Rated',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Boolean',0,1,'0',0,NULL),(148,4,'available_shipping_methods',NULL,'MageWorx\\ShippingRules\\Model\\Attribute\\Backend\\AvailableShippingMethods','text',NULL,'MageWorx\\ShippingRules\\Model\\Attribute\\Frontend\\AvailableShippingMethods','multiselect','Available Shipping Methods',NULL,'MageWorx\\ShippingRules\\Model\\Attribute\\Source\\AvailableShippingMethods',0,0,NULL,0,NULL),(149,4,'bss_productattachment',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','varchar',NULL,NULL,'multiselect','File Attachment',NULL,'Bss\\ProductAttachment\\Model\\Attribute\\Source\\File',0,0,NULL,0,NULL),(150,4,'hide_shipping_calculator',NULL,'Magento\\Catalog\\Model\\Product\\Attribute\\Backend\\Boolean','int',NULL,NULL,'boolean','Hide Shipping Calculator',NULL,'Magento\\Catalog\\Model\\Product\\Attribute\\Source\\Boolean',0,0,'0',0,NULL),(151,3,'hide_shipping_calculator',NULL,'Magento\\Catalog\\Model\\Product\\Attribute\\Backend\\Boolean','int',NULL,NULL,'boolean','Hide Shipping Calculator',NULL,'Magento\\Catalog\\Model\\Product\\Attribute\\Source\\Boolean',0,0,'0',0,NULL),(152,4,'heat_output',NULL,NULL,'varchar',NULL,NULL,'text','Heat Output',NULL,NULL,0,1,NULL,0,NULL),(153,3,'category_custom_editorup',NULL,NULL,'text',NULL,NULL,'textarea','Category Bottom content',NULL,NULL,0,1,NULL,0,NULL),(155,4,'imegamedia_finance_filter',NULL,NULL,'text',NULL,NULL,'text','Imegamedia Finance Filter',NULL,NULL,0,0,NULL,0,NULL),(156,4,'price_per_unit',NULL,NULL,'text',NULL,NULL,'text','Price Per Unit',NULL,NULL,0,0,'0',0,NULL),(157,1,'mp_smtp_is_synced',NULL,NULL,'int',NULL,NULL,'hidden','Mp SMTP is synced',NULL,NULL,0,0,NULL,0,NULL),(158,3,'magic_label',NULL,NULL,'varchar',NULL,NULL,'text','Label','validate-length maximum-length-255',NULL,0,0,NULL,0,'Example: New,Hot,... Maximum 255 chars'),(159,3,'magic_thumbnail',NULL,'Magento\\Catalog\\Model\\Category\\Attribute\\Backend\\Image','varchar',NULL,NULL,'image','Thumbnail',NULL,NULL,0,0,NULL,0,NULL),(160,3,'magic_image',NULL,'Magento\\Catalog\\Model\\Category\\Attribute\\Backend\\Image','varchar',NULL,NULL,'image','Image',NULL,NULL,0,0,NULL,0,NULL),(161,4,'featured',NULL,NULL,'int',NULL,NULL,'boolean','Featured Product',NULL,NULL,0,1,NULL,0,NULL),(162,4,'product_brand',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','varchar',NULL,NULL,'multiselect','Product Brand',NULL,'Ves\\Brand\\Model\\Brandlist',0,1,NULL,0,NULL),(163,3,'is_home',NULL,NULL,'int',NULL,NULL,'boolean','Is Home Category',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Boolean',0,0,'0',0,NULL),(164,4,'pressure_bar',NULL,NULL,'int',NULL,NULL,'select','pressure_bar',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Table',0,1,'',0,NULL),(165,4,'offer',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','text',NULL,NULL,'multiselect','Offer',NULL,NULL,0,1,'',0,NULL),(166,4,'cabinet_width',NULL,NULL,'int',NULL,NULL,'select','Cabinet Width',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Table',0,1,'',0,NULL),(167,4,'material',NULL,NULL,'int',NULL,NULL,'select','Material',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Table',0,1,'',0,NULL),(168,4,'mount_type',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','text',NULL,NULL,'multiselect','Mount Type',NULL,NULL,0,1,'',0,NULL),(169,4,'number_of_bowls',NULL,NULL,'int',NULL,NULL,'select','Number of Bowls',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Table',0,1,'',0,NULL),(170,4,'products_by_category',NULL,NULL,'int',NULL,NULL,'select','products_by_category',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Table',0,1,'',0,NULL),(171,4,'bath_length',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','text',NULL,NULL,'multiselect','Bath Length',NULL,NULL,0,1,'',0,NULL),(172,4,'bath_style',NULL,NULL,'int',NULL,NULL,'select','Bath Style',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Table',0,1,'',0,NULL),(173,4,'bath_type',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','text',NULL,NULL,'multiselect',' Bath Type',NULL,NULL,0,1,'',0,NULL),(174,4,'glass_thickness',NULL,NULL,'int',NULL,NULL,'select','Glass Thickness',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Table',0,1,'',0,NULL),(175,4,'tap_style',NULL,NULL,'int',NULL,NULL,'select','Tap Style',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Table',0,1,'',0,NULL),(176,4,'tap_type',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','text',NULL,NULL,'multiselect','Tap type',NULL,NULL,0,1,'',0,NULL),(177,4,'basin_width',NULL,NULL,'int',NULL,NULL,'select','Basin Width',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Table',0,1,'',0,NULL),(178,4,'basin_depth',NULL,NULL,'int',NULL,NULL,'select','Basin Depth',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Table',0,1,'',0,NULL),(179,4,'flush_type',NULL,NULL,'int',NULL,NULL,'select','Flush Type',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Table',0,1,'',0,NULL),(180,4,'toilet_width',NULL,NULL,'int',NULL,NULL,'select','Toilet Width',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Table',0,1,'',0,NULL),(181,4,'toilet_style',NULL,NULL,'int',NULL,NULL,'select','Toilet Style',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Table',0,1,'',0,NULL),(182,4,'toilet_projection',NULL,NULL,'int',NULL,NULL,'select','Toilet Projection',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Table',0,1,'',0,NULL),(183,4,'toilet_full_height',NULL,NULL,'int',NULL,NULL,'select','Toilet Full Height',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Table',0,1,'',0,NULL),(184,4,'installation',NULL,NULL,'int',NULL,NULL,'select','Installation',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Table',0,1,'',0,NULL),(185,4,'fuel_type',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','text',NULL,NULL,'multiselect','Fuel Type',NULL,NULL,0,1,'',0,NULL),(186,4,'colour',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','text',NULL,NULL,'multiselect','Colour',NULL,NULL,0,1,'',0,NULL),(187,4,'built_type',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','text',NULL,NULL,'multiselect','Built Type',NULL,NULL,0,1,'',0,NULL),(188,4,'oven_type',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','text',NULL,NULL,'multiselect','Oven Type',NULL,NULL,0,1,'',0,NULL),(189,4,'cleaning',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','text',NULL,NULL,'multiselect','Cleaning',NULL,NULL,0,1,'',0,NULL),(190,4,'size',NULL,NULL,'int',NULL,NULL,'select','Size',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Table',0,1,'',0,NULL),(191,4,'number_of_cooking_zones',NULL,NULL,'int',NULL,NULL,'select','Number of Cooking Zones',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Table',0,1,'',0,NULL),(192,4,'hoods_type',NULL,NULL,'int',NULL,NULL,'select','Hoods Type',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Table',0,1,'',0,NULL),(193,4,'hob_type',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','text',NULL,NULL,'multiselect','Hob Type',NULL,NULL,0,1,'',0,NULL),(194,4,'hoods_width_mm',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','text',NULL,NULL,'multiselect','Hoods Width (mm)',NULL,NULL,0,1,'',0,NULL),(195,4,'fire_width',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','text',NULL,NULL,'multiselect','Fire Width',NULL,NULL,0,1,'',0,NULL),(196,4,'fire_type',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','text',NULL,NULL,'multiselect','Fire Type',NULL,NULL,0,1,'',0,NULL),(197,4,'fire_style',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','text',NULL,NULL,'multiselect',' Fire Style',NULL,NULL,0,1,'',0,NULL),(198,4,'fire_frontage',NULL,NULL,'int',NULL,NULL,'select','Fire Frontage',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Table',0,1,'',0,NULL),(199,4,'fit_type',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','text',NULL,NULL,'multiselect','Fit type',NULL,NULL,0,1,'',0,NULL),(200,4,'features',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','text',NULL,NULL,'multiselect','Features',NULL,NULL,0,1,'',0,NULL),(201,4,'height',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','text',NULL,NULL,'multiselect','Height',NULL,NULL,0,1,'',0,NULL),(202,4,'defrost_type',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','text',NULL,NULL,'multiselect','Defrost Type',NULL,NULL,0,1,'',0,NULL),(203,4,'unit_width',NULL,NULL,'int',NULL,NULL,'select','Unit Width',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Table',0,1,'',0,NULL),(204,4,'configuration',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','text',NULL,NULL,'multiselect','Configuration',NULL,NULL,0,1,'',0,NULL),(205,4,'radiator_style',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','text',NULL,NULL,'multiselect','Radiator Style',NULL,NULL,0,1,'',0,NULL),(206,4,'output_btu',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','text',NULL,NULL,'multiselect','Output (BTU)',NULL,NULL,0,1,'',0,NULL),(207,4,'radiator_height',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','text',NULL,NULL,'multiselect','Radiator Height',NULL,NULL,0,1,'',0,NULL);
/*!40000 ALTER TABLE `eav_attribute` ENABLE KEYS */;
UNLOCK TABLES;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2025-02-05  8:12:49
